/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/Parsergen/LRconst.java,v 1.1.1.1 2000/09/19 19:39:44 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/
/*
*
* $Author: bhunt $
* $Revision: 1.1.1.1 $
* $Log: LRconst.java,v $
* Revision 1.1.1.1  2000/09/19 19:39:44  bhunt
* Initial Population
*
* Revision 1.1.1.1  2000/08/17 17:50:08  bhunt
* Initial Code Upload
*
* Revision 1.2  1999/09/19 07:47:15  bhunt
* LRconst is now it's own java file.
*
* Revision 1.1  1999/09/19 06:55:49  bhunt
* Initial revision
*
*/
/*--------------------------------------------------------------------------+
 |                                                                          |
 |            CLASS LRconst - Manifest Constants for Parsergen              |
 |                                                                          |
 +--------------------------------------------------------------------------*/
package com.adobe.rice.common.Parsergen;
import java.io.*;
import java.text.*;
import java.util.*;
//$JDK1.1$ import com.sun.java.util.collections.*;

public class LRconst
{
    public final static int     RHS_SYMBOL_COUNT = 10;
    public final static int     PRODUCTION_COUNT = 50;
    public final static int     SYMBOL_COUNT 	 = 150;
    public final static int     STATE_COUNT	     = 300;
    public final static int     STACK_DEPTH      = 100;
    public final static boolean NONTERMINAL 	 = true;
    public final static boolean TERMINAL	     = false;
    public final static String 	ROOT 		     = "~ROOT";
    public final static String 	EMPTY 		     = "!!EMPTY!!";
    public final static String	ATEND		     = "~END";
    public final static int     DEBUG            = 5;        // debug value - 0 off
    public final static String  INDENTURE	     = "  ";	 // default indent


    public static String indent( int indentLevel )
    {
        String prefix = "";
        int    index = 0;
        for ( index = 0; index < indentLevel; index++ )
            prefix += LRconst.INDENTURE;
        return prefix;
    }

    // silly little routine to generate a string of blanks.
    //
    public static String genBlanks( int num )
    {
        String r = "";
        for ( int i = 0; i < num ; i++ )
            r += " ";
        return r;
    }

    public String toStringCore( int ind )
    {
        String lrp = indent( ind ) + "LRconst --> [\n";

        ind++;
        lrp += indent( ind ) + "RHS_SYMBOL_COUNT = " + 
               ( new Integer(RHS_SYMBOL_COUNT)).toString() +"\n";
        lrp += indent( ind ) + "PRODUCTION_COUNT = " + 
               ( new Integer(PRODUCTION_COUNT)).toString() + "\n";
        lrp += indent( ind ) + "SYMBOL_COUNT = " + 
               ( new Integer(SYMBOL_COUNT)).toString() + "\n";
        lrp += indent( ind ) + "STATE_COUNT = " + 
               ( new Integer(STATE_COUNT)).toString() + "\n";
        lrp += indent( ind ) + "NONTERMINAL = " + NONTERMINAL + "\n";
        lrp += indent( ind ) + "TERMINAL = " + TERMINAL + "\n";
        lrp += indent( ind ) + "ROOT = " + ROOT + "\n";
        lrp += indent( ind ) + "EMPTY = " + EMPTY + "\n";
        lrp += indent( ind ) + "ATEND = " + ATEND + "\n";
        lrp += indent( ind ) + "DEBUG = " + ( new Integer( DEBUG )).toString() + "\n";
        lrp += indent( ind ) + "INDENTURE = " + "->|" + INDENTURE + "|<-\n";
        ind--;
        lrp += "]\n";
        return lrp;
    }

    public String toString() { return toStringCore( 0 ); }

}






