/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/Parsergen/Production.java,v 1.1.1.1 2000/09/19 19:39:45 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/
/**
*
* $Author: bhunt $
* $Revision: 1.1.1.1 $
* $Log: Production.java,v $
* Revision 1.1.1.1  2000/09/19 19:39:45  bhunt
* Initial Population
*
* Revision 1.1.1.1  2000/08/17 17:50:08  bhunt
* Initial Code Upload
*
* Revision 1.2  1999/09/19 07:48:40  bhunt
* Production is now it's own java file.
*

* Revision 1.1  1999/09/19 07:06:43  bhunt
* Initial revision
*
*/

/*--------------------------------------------------------------------------+
 |                                                                          |
 |            CLASS Production - Grammar rewrite rule                       |
 |                                                                          |
 +--------------------------------------------------------------------------*/

package com.adobe.rice.common.Parsergen;

import java.io.*;
import java.text.*;
import java.util.*;
//$JDK1.1$ import com.sun.java.util.collections.*;

/*--------------------------------------------------------------------------+
 |                                                                          |
 |      CLASS Production - represent A -> Y1 Y2 ... Yk of a Grammar         |
 |                                                                          |
 +--------------------------------------------------------------------------*/

public class Production
{
    Symbol        nS;	 // non terminal symbol in the grammar.
    ArrayList 	  rhs;	 // list of symbols on the right hand side of the  production.
	
    public Production()
    {
        nS = new Symbol(LRconst.ROOT, LRconst.NONTERMINAL );
        rhs = new ArrayList( LRconst.RHS_SYMBOL_COUNT );
    }
    
    public Production( Symbol s )
    {
        nS = s;
        rhs = new ArrayList( LRconst.RHS_SYMBOL_COUNT );
    }
	
    public Production( String s )
    {
        nS = new Symbol( s, LRconst.NONTERMINAL );
        rhs = new ArrayList( LRconst.RHS_SYMBOL_COUNT );
    }
	
    public Symbol getLHS() { return nS; }
    public Symbol getNS() { return nS; }
	
    public void setLHS( Symbol s ) { nS = s; }
	
    public void add( Symbol s ) { rhs.add( s ); }
	
    public void add( int i, Symbol s ) { rhs.add( i, s ); }
	
    public void clear()
    {
        nS = Symbol.empty;
       	rhs.clear();
    }
	
    public Symbol get( int i ) 
    { 
    	if ( (i >= 0) && ( i < rhs.size() ) )
            return (Symbol) rhs.get(i);
        return null;
    }
	
    public void set( int i, Symbol s ) { rhs.set( i, s ); }
	
    public void remove( int i ) { rhs.remove( i ); }
	
    public boolean isEmpty() { return rhs.isEmpty(); }
	
    public int indexOf( Symbol s ) { return rhs.indexOf( s ); }
	
    public int lastIndexOf( Symbol s ) { return rhs.lastIndexOf( s ); }
	
    public int size() { return rhs.size(); }
	
    public boolean contains( Symbol s ) { return rhs.contains(s); }
	
    public void ensureCapacity( int minCapacity ) { rhs.ensureCapacity( minCapacity ); }
	
    public boolean equals( Production ap )
    {
        if ( ! nS.equals(ap.nS) )
            return false;
        if ( rhs.size() == ap.rhs.size() )
        {   // compare each of the symbols
            for ( int i = 0; i < rhs.size(); i++ )
            {
                Symbol r = (Symbol) rhs.get(i);
                Symbol ar = (Symbol) ap.rhs.get(i);
                if ( ! r.equals(ar) )
                    return false;
            }
            return true;
        }
        return false;
    }

    public String toStringCore(int ind)
    {
        String prod = LRconst.indent(ind);
        prod += nS.toString() + " ::= " ;
        for ( int i = 0; i < rhs.size(); i++ )
        {
            prod += get(i).toString() + " ";
        }
        prod += " ";
        return prod;
    }

    public String toString() { return toStringCore( 0 ); }

    public void debugPrint()
    {
        System.out.println( this.toString() );
    }
}	














