/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/Parsergen/ProductionItem.java,v 1.1.1.1 2000/09/19 19:39:45 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/

/**
*
* $Author: bhunt $
* $Revision: 1.1.1.1 $
* $Log: ProductionItem.java,v $
* Revision 1.1.1.1  2000/09/19 19:39:45  bhunt
* Initial Population
*
* Revision 1.1.1.1  2000/08/17 17:50:08  bhunt
* Initial Code Upload
*
* Revision 1.2  1999/09/19 07:48:52  bhunt
* ProductionItem is now it's own java file.
*
* Revision 1.1  1999/09/19 07:10:27  bhunt
* Initial revision
*
*/

/*--------------------------------------------------------------------------+
 |                                                                          |
 |   CLASS ProductionItem - represent Production and distinguished point    |
 |                                                                          |
 +--------------------------------------------------------------------------*/
package com.adobe.rice.common.Parsergen;

import java.io.*;
import java.text.*;
import java.util.*;
//$JDK1.1$ import com.sun.java.util.collections.*;
//
//	ProductionItem ::= [ A -> c1 c2 ... cn, dp, terminal ]
//
public class ProductionItem 
{
    Production	p;	//  production of the form  A -> c1 c2 ... ci ... cn
    int 	dp;		//  distinguished position
    Symbol	la;		//  Look ahead symbol, terminal
	
    public ProductionItem()
    {
        p = null;
        dp = 0;
        la = Symbol.empty;
    }
	
    public ProductionItem( Production pn )
    {
     	this();
     	p = pn;
    }
	
    public ProductionItem( Production pn, int d )
    {
       	this();
       	p = pn;
       	dp = d;
    }
	
    public ProductionItem( Production pn, int d, Symbol s )
    {
    	this();
        p = pn;
      	dp = d;
       	la = s;
    }
	
    public Production getP() { return p; }
    public void setP( Production c ) { p = c; }
	
    int getDp() { return dp; }
    void setDp( int d ) { dp = d; }
	
    Symbol getLa() { return la; }
    void setLa( Symbol s ) { la = s; }
	
    boolean equals( ProductionItem pi )
    {
        final int DEBUGLEVEL = 8;	// Routine's Debug Level

        if ( LRconst.DEBUG > DEBUGLEVEL )
        {
            System.out.println("Entering Production Item equals.");
            System.out.println( this.toStringCore(2) + " ?==? " + pi.toString() );
        }
        if ( ! la.equals( pi.la ) )
            return false;
        if ( dp != pi.dp )
            return false;
        if ( ! p.equals( pi.p ) )
            return false;
        return true;
    }

    public String toStringCore(int ind)
    {
        // prototype:  Production Item --> [ { A ==> b c <> d e f }, 2, s ]
        Integer idp = new Integer(dp);
        String prit = LRconst.indent(ind) + "[ ";
        prit += "{ " +  p.getLHS().toString() ;
        prit += " ::= ";
        for ( int i = 0; i < p.size(); i++ )
        {
            if ( i == dp )
                prit += "<> ";
            prit += p.get(i) + " ";
        }
        if ( dp == p.size() )
            prit += "<> ";
        prit += "}, ";
        prit += idp.toString();
        prit += ", ";
        prit += la.getS();
        prit += " ] ";
        return prit;
    }

    public String toString() { return toStringCore( 0 ); }

    void debugPrint()
    {
        System.out.println(this.toString());
    }

}









