/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/Parsergen/SymbolFirst.java,v 1.1.1.1 2000/09/19 19:39:45 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/
/*
*
* $Author: bhunt $
* $Revision: 1.1.1.1 $
* $Log: SymbolFirst.java,v $
* Revision 1.1.1.1  2000/09/19 19:39:45  bhunt
* Initial Population
*
* Revision 1.1.1.1  2000/08/17 17:50:08  bhunt
* Initial Code Upload
*
* Revision 1.2  1999/09/19 07:50:02  bhunt
* SymbolFirst is now it's own java file.
*
* Revision 1.1  1999/09/19 07:14:27  bhunt
* Initial revision
*
*/
/*------------------------------------------------------------------------------+
 |                                                                              |
 |			    CLASS SymbolFirst -- keep list of FIRST(Symbol)                 |
 |											                                    |
 +------------------------------------------------------------------------------*/

package com.adobe.rice.common.Parsergen;

import java.io.*;
import java.text.*;
import java.util.*;
//$JDK1.1$ import com.sun.java.util.collections.*;

/**
@class SymbolFirst -- used to keep the list of symbols that are in the FIRST of a symbol.
**/
public class SymbolFirst
{
    Symbol     s;
    HashSet    hs;
	
    public SymbolFirst()
    {
        s = Symbol.empty;
        hs = new HashSet(LRconst.SYMBOL_COUNT);
    }
	
    public SymbolFirst( Symbol ns )
    {
        s = ns;
        hs = new HashSet(LRconst.SYMBOL_COUNT);
    }
	
    public void setS( Symbol ns ) { s = ns; }
    public Symbol getS() { return s; }
	
    public HashSet getHs() { return hs; }
    public void setHs( HashSet h ) { hs = h; }
	
    public boolean add( Symbol s ) { return hs.add(s); }
	
    public boolean contains( Symbol c ) { return hs.contains( c ); }
	
    public Iterator iterator() { return hs.iterator(); };
	
    public int size() { return hs.size(); }

    public String toStringCore( int ind )
    {
        String sf = LRconst.indent(ind) + "FIRST(" + s.toString() + ") = { ";
        Iterator si = this.iterator();
        while ( si.hasNext() )
	    {
            Symbol sym  = (Symbol) si.next();
            sf += sym.toString();
            if ( si.hasNext() ) sf += ", ";
	    }
        sf += " } ";
        return sf;
    }

    public String toString()
    {
        return toStringCore( 0 );
    }
} 




































