/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/XMLassembly/Comment.java,v 1.1.1.1 2000/09/19 19:39:50 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/
/*----------------------------------------------------------------------------------+
 |                                                                                  |
 |                                Comment - XML Comment                             |
 |                                                                                  |
 +----------------------------------------------------------------------------------*/

package com.adobe.rice.common.XMLassembly;

import java.util.*;
import java.io.*;
import java.text.*;
//$JDK1.1$ import com.sun.java.util.collections.*;

public class Comment implements Serializable, XMLexpandable
{
    private String c = "";
    
    public Comment() { c = ""; }
    
    public Comment( String t ) { c = t; }
    
    public void set( String aTarget ) { c = aTarget; }

    public String get() { return c; }

    //
    // implement XML expandable
    //
    
    public boolean canDoCharData() { return false; }
    public String toCDSect() { return ""; }
    public String toCharData() { return ""; }

    public String toXMLstring()
    {
    	return "<!--" + c + " -->\n";
    }
    
    //
    // Parsing Routine
    //
    
    public int parse( ScanToken t ) throws XMLparseException
    {	
        // Comments are handled automatically by the scanner.
        int count = 0;
	
        if ( t.type == ScanToken.COMMENT )
        {
            // place the comment in the Misc.
            c = t.string;
            ++count;
        }
        return count;
    }	
    
}








