/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/XMLassembly/ContentModel.java,v 1.1.1.1 2000/09/19 19:39:50 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/

package com.adobe.rice.common.XMLassembly;

import java.io.*;

public class ContentModel implements Serializable
{
    final static byte CM_EMPTY = 0;
    final static byte CM_ANY = 1;
    final static byte CM_MIXED = 2;
    final static byte CM_CHILDREN = 3;

    private byte type;
    private Mixed model;
    private ElementDecl element;
    
    private XMLscanner scan = null;
    
    //
    // Constructors
    //
    public ContentModel()
    {
    	type = CM_EMPTY;
    	model = null;
    	element = null;
    }
    
    public ContentModel( ElementDecl eDecl )
    {
    	this();
    	element = eDecl;
    	if ( element != null )
    		scan = element.getScan();
    }
    
    public ContentModel( byte aType, ElementDecl eDecl )
    {
    	this();
    	type = aType;
    	element = eDecl;
    	if ( element != null )
    		scan = element.getScan();
    }
    //
    // setters and getters
    //
    public byte getType() { return type; }
    public Mixed getModel() { return model; }
    public ElementDecl getElementDecl() { return element; }
    
    public void setType( byte aType ) { type = aType; }
    public void setModel( Mixed mdl ) { model = mdl; }
    public void setElementDecl ( ElementDecl ed ) 
    { 	
    	element = ed;  
    	if ( ed != null) 
    		scan = ed.getScan(); 
    	else 
    		scan = null; 
    }
    
    //
    // Methods
    //
    public boolean beginContentAssembly()
    {
    	return true;
    }

    public void endContentAssembly() throws ElementException
    {
    }

    public int insertText(String newText) throws ElementException
    {
    	return 0;
    }

    public int insertEntity(String entityName) throws ElementException
    {
    	return 0;
    }

    public int insertElement(ElementDecl newElementDecl) throws ElementException
    {
    	return 0;
    }

    public Cp getContentModel()
    {
    	return null;
    }

    public Cp getContentModel(ElementDecl elementDecl )
    {
    	return null;
    }

    public boolean okToInsertText()
    {
    	return true;
    }

    public boolean okToInsertEntity(EntityDecl newEntityDecl)
    {
    	return true;
    }

    public boolean okToInsertElement(Element newElement)
    {
    	return true;
    }
    
    //
    //	Recursive descent parse routines
    //
    // contentspec ::= 'EMPTY' | 'ANY' | Mixed | children 
    //
    public int parseContentModel( ScanToken t ) throws XMLparseException
    {
     	int	count = 0;
     	int gotOne = 0;
    	String msg = null;
    	XMLparseException pBad = null;
    	
    	if ( t.string.equals("EMPTY") )
    	{
    		type = CM_EMPTY;
    		count = 1;
    	}
    	else if ( t.string.equals("ANY") )
    	{
    		type = CM_ANY;
    		count = 1;
    	}
    	else // must be Mixed or children 
    	{
    	}
    	return count;
   }
}
