/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/XMLassembly/Messages.java,v 1.2 2000/12/02 23:31:44 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/
/*----------------------------------------------------------------------------------+
 |                                                                                  |
 |                             Messages for XMLassembly                             |
 |                                                                                  |
 +----------------------------------------------------------------------------------*/

package com.adobe.rice.common.XMLassembly;

public class Messages
{
    //
    //	Package Identifier
    //

    public static final String packageName = "XMLassembly";

    //
    // XMLscanner error messages
    //

    public static final String lineEndInvalid = "XML scanner: Line end option, {0}, is invalid.\n" 
		+ "The XML default, lf (linefeed), is assumed.";
		
    public static final String unknownScanState = "XML scanner: Unknown state, {0, number}, error! \n" 
        + "Line = ->|{1,String}|<- \n index = {2, number}!";

    public static final String tokenScanned = "XML scanner: State={0, number}, token={1}, tokenLength={2, number}, string = |{3}|";


    //
    // Error messages
    //
    public static final String tokenError = "Expecting {0}; got token error instead.  Token was:\n {1}";

    public static final String unexpected = "Expecting {0} where token, {1}, appeared.";

    public static final String illegal = "The string, {0}, is not allowed {1}.";

    public static final String undeclared = "{0} is not declared as {1}.";

    public static final String errorLocation = "In text beginning on line {0,number} at column {1,number}" + 
							" through line {2,number} at column {3,number}." ;
							
    public static final String indexOutOfRange = "{0} index, {1, number}, is not in the defined range from " 
    + "{2, number} through {3, number}.";
    //
    // Document error messages:
    //
    public static final String docUpdateInvalid = "XML document update invalid: {0}!";
    public static final String documentNotOpen = "The document is not open.  operation {0} of {1} is illegal.";
    public static final String documentEmpty = "The document is empty, operation, {0} of {1} is illegal.";
	public static final String documentIndexInvalid = "Document part {0} {1} operation content index ranges from " +
	            "{2,number} to {3, number}, and {4, number} is not in it!";
	//
	// XMLdecl error messages:
	//
	public static final String xmlDeclAttributeInvalid = "XMLdecl attribute, {0}, is invalid: {1}!";
	//
	// docType attributes error messages:
	//
	public static final String docTypeAttributeInvalid = "DocType attribute, {0}, is invalid: {1}!";
    //
    // Entity error messages:
    //
    public static final String entityUndeclared = "{0} entity, {1}, is not declared in the DTD."; 
    //
    // Element error messages:
    //
    public static final String element_not_root = "Element, {0}, is not the root element in the DTD.";
    public static final String element_undeclared = "Element, {0}, is not declared in the DTD.";
    public static final String element_attribute_undeclared = "Attribute, {0}, is not declared for element, {1}!";
    public static final String element_conflict = "Element: Cannot set element name to existing element name,{0}!";
    public static final String element_prefix_conflict = "Element:  Cannot place element,{0}, currently in " +
    			"name space, {1}, into undeclared name space, {2}!";
    public static final String element_content_invalid = "Element, {0}'s content model does not permit content of type, " +
				"{1} here.";
    public static final String element_content_remove_invalid = "Element, {0}'s content becomes invalid with removal of " +
				"content of type, {1} here. ";
    public static final String element_content_replace_invalid = "Element, {0}'s content becomes invalid with replacement " +
				" of content of type, {1} at index, {2,number}, with content of type, {3}.";
    public static final String element_logic_error = "Element, {0}, logic error -- {1}. "+
				" \nCurrent element is {2}.  Please report this error!";
	public static final String element_not_open = "Element, {0}, is not open for content update." +
	            " Cannot add, delete or replace {1}!";
	public static final String element_index_invalid = "Element, {0}, content index ranges from " +
	            "{1,number} to {2, number}, and{3, number} is not in it!";
	public static final String element_is_empty = "Element, {0}, defined to be empty. Cannot update " +
	            "it with, {1}.";
    //
    // Attribute error messages
    //
    public static final String attribute_undeclared = "Attribute {0} is not declared in the DTD.";
    public static final String attributeNotInList   = "Attribute {0} with value {1}, is not in the {2} list of valid values.!";
    public static final String attributeMiscIllegal = "Attributes such as, {0}, on PIs or Comments are not allowed.";
    public static final String attributeTypeIllegal = "Attribute {0} with value {1} is NOT of type {2}.";
    //
    // External Subset Error messages
    //
    public static final String extsubset_empty = "External DTD subset is empty.";
    public static final String extsubset_section_illegal = "An external DTD subset may NOT " +
                 "contain a section name, {0}.";
    //===========================================================================================
    //
    // String fragments - referenced in this package
    //
    public static final String frag_Element = "Element";
    public static final String frag_Attribute = "Attribute";
    public static final String frag_Attrval = "Attribute value";
    public static final String frag_ContentReference = "Content Reference";
    public static final String frag_XmlDecl = "XML Decl";
    public static final String frag_DocType = "Document Type";
    public static final String frag_PI = "PI";
    public static final String frag_Comment = "Comment";
    
    public static final String frag_OprAdd = "Add";
    public static final String frag_OprReplace = "Replace";
    public static final String frag_OprDelete = "Delete";
    
    
    public static final String frag_ContentType = "Content type";

    public static final String frag_ContentTypeName = "Content type name";
    public static final String frag_DocumentEmpty = "Document contains no elements";
    public static final String frag_NoParser = "cannot update content, no parser!";
    public static final String frag_InvalidContent = "content is invalid!";
    public static final String frag_UpdateTypeInvalid = "updateType is not ADD, REPLACE or DELETE";
    public static final String frag_CommentThereBad = "A comment cannot be placed here";
    public static final String frag_PiThereBad = "A PI cannot be placed here";
    public static final String frag_ElementThereBad = "An element cannot be placed here";
    public static final String frag_ContentThereBad = "Content (CDATA or CharData) cannot be placed here";
    
    //    

}







