/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/XMLassembly/SectionDefinition.java,v 1.1.1.1 2000/09/19 19:39:50 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/
/*----------------------------------------------------------------------------------+
 |                                                                                  |
 |                             SectionDefinition Class                              |
 |                                                                                  |
 +----------------------------------------------------------------------------------*/

package com.adobe.rice.common.XMLassembly;

import java.io.*;
import java.util.*;
import com.sun.java.util.collections.*;
//
//	Things to fix.
//	 
public class SectionDefinition
{
    //
    // index definitions of sections
    //
    final static byte CDATA   = 0;
    final static byte INCLUDE = 1;
    final static byte IGNORE  = 2;
    final static byte UNKNOWN = 3;      // any unknown section -  make it the last!
    final static byte COUNT   = 4;      // the number of sections defined (3 plus UNKNOWN = 4 )
    // add static new section types here...

    String         name;
    byte	       type;
    static boolean initial = false;
	
    SectionDefinition( )
    {
        name = "";
        type = 0;
        if ( ! initial )
        {
            initial = true; // MUST be first to avoid recursion !
            sections[CDATA] = new SectionDefinition( "CDATA",   ScanToken.SECTION_CDATA );
            sections[INCLUDE] = new SectionDefinition( "INCLUDE", ScanToken.SECTION_INCLUDE );
            sections[IGNORE] = new SectionDefinition( "IGNORE",  ScanToken.SECTION_IGNORE );
            sections[UNKNOWN] = new SectionDefinition( "UNKNOWN", ScanToken.SECTION_UNKNOWN );
            // define new section types here -- update index definitions as well.
        }	    	
    }
	
    SectionDefinition( String n, byte t ) 
    {
        this();
        name = n;
        type = t;
    }

    public static SectionDefinition[] sections = new SectionDefinition[COUNT];

    //
    // Methods
    //
    static public byte getIndex( String name )
    {
        int i;
        
        for ( i = 0; i < SectionDefinition.sections.length; i++ )
        {
            if ( name.equals( SectionDefinition.sections[i].name ) )
                return (byte) i;
        }
        return UNKNOWN;
    }

    static public String getName( byte index )
    {
        if ( ( index >= 0 ) && ( index < SectionDefinition.sections.length ) )
            return SectionDefinition.sections[index].name;
        return SectionDefinition.sections[UNKNOWN].name;
    }
}












