/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/XMLdisassembly/AttributeEntry.java,v 1.3 2000/11/22 21:18:45 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/

package com.adobe.rice.common.XMLdisassembly;

import java.util.*;
import org.xml.sax.*;

public class AttributeEntry
{
    String qName;                // This is the XML 1.0 qualified name (all of "x:y")
    String localName;           // This is the XML 1.0 local name (only "y" in "x:y")
    String type;
    String value;
    
    public AttributeEntry()
    {
        qName = "";
        localName = "";
        type = "";
        value = "";
    }
    
    public AttributeEntry( String qn )
    {
        qName = qn;
        type = "";
        value = "";
    }
    
    public AttributeEntry( String qn, String t )
    {
        qName = qn;
        type = t;
    }
    
    public AttributeEntry( String qn, String t, String v )
    {
        qName = qn;
        type = t;
        value = v;
    }
    
    public AttributeEntry( String qn, String ln, String t, String v )
    {
        qName = qn;
        localName = ln;
        type = t;
        value = v;
    }
    
    public String getName() { return qName; }
    public String getQName() { return qName; }
    public String getLocalName() { return localName; }
    public String getType() { return type; }
    public String getValue() { return value; }
    public String get() { return value; }
    
    public void setName( String n ) { qName = n; }
    public void setQName( String qn ) { qName = qn; }
    public void setLocalName( String ln ) { localName = ln; }
    public void setType( String t ) { type = t; }
    public void setValue( String v ) { value = v; }
    
    public void set( String v ) { value = v; }
}