/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/XMLdisassembly/Constants.java,v 1.1.1.1 2000/09/19 19:39:50 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/
/*----------------------------------------------------------------------------------+
 |                                                                                  |
 |                             Constants for XMLdisassembly                         |
 |                                                                                  |
 +----------------------------------------------------------------------------------*/

package com.adobe.rice.common.XMLdisassembly;

final public class Constants
{
    final static int EXPECTED_HANDLER_COUNT = 100;
    final static float HANDLER_HASHMAP_LOADFACTOR = (float) 0.80;
    final static int MAXIMUM_HANDLER_STACKSIZE = 100;
    final static int EXPECTED_ATTRIBUTE_COUNT = 10;
    
    //
    // The following defines the handler registry name for several standard
    // routines:
    //      XML document name - The default registry name for a document handler.  It is
    //                          used to register a handler that is called when a document
    //                          begins or ends.
    //      Warning name -      The defualt registry name for the routine called for 
    //                          a parser warning.  It is used to register a handler that
    //                          is called when the parser detects a warning level error.
    //      Error name -        The default registry name for the routine called for a 
    //                          parser error.  It is used to register a handler that is
    //                          called when the parser detects an error level error.
    //      Fatal Error name -  The default registry name for the routine called for a parser
    //                          fatal error. It is used to register a handler that is
    //                          called whenthe parser detects a fatal level error.
    //
    // The actual name is, of course, the prefix name concatenated with one of the
    // above names.
    //       
    // See XMLDisassembler implementation for implementation use.
    //
    
    final static String DOCUMENT_NAME = "@DOCUMENT@";
    final static String DOCUMENT_LOCATOR = "@LOCATOR@";
    final static String WARNING_HANDLER_NAME = "@WARNING@";
    final static String ERROR_HANDLER_NAME = "@ERROR@";
    final static String FATAL_HANDLER_NAME = "@FATAL@";
    
    //
    // The default parsing error messages when there are no handlers for the
    // exceptions thrown.
    //
    final static String PARSER_WARNING_DEFAULT_MESSAGE = "Parsing warning exception thrown because {0}.";
    final static String PARSER_ERROR_DEFAULT_MESSAGE = "Parser error exception thrown because {0}.";
    final static String PARSER_FATAL_DEFAULT_MESSAGE = "Parser fatal exception thrown because {0}.";
    
}



