/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/XMLdisassembly/ParserAttributes.java,v 1.2 2000/09/25 00:51:12 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/

package com.adobe.rice.common.XMLdisassembly;

import java.util.*;
import org.xml.sax.*;

public class ParserAttributes
{
    private ArrayList list;
    
    public ParserAttributes()
    {
        list = new ArrayList( Constants.EXPECTED_ATTRIBUTE_COUNT );
    }
    public boolean isEmpty() { return list.isEmpty(); }
    public boolean add( AttributeEntry ae ) { return list.add( ae ); }
    public void add( int index, AttributeEntry ae ) { list.add( index, ae ); }
    public void ensureCapacity( int minCapacity) { list.ensureCapacity(minCapacity); } 
    public void trimToSize() { list.trimToSize(); }
    public boolean addAll( Collection c) { return list.addAll(c); };
    public boolean addAll( int index, Collection c) { return list.addAll( index, c ); }
    public void clear( ){ list.clear(); }
    public boolean contains( AttributeEntry ae){ return list.contains(ae); }
    public AttributeEntry get( int index) { return (AttributeEntry) list.get(index); }
    public int indexOf( AttributeEntry ae) { return list.indexOf(ae); }
    public int lastIndexOf( AttributeEntry ae) { return list.lastIndexOf(ae); }
    public AttributeEntry remove( int index) { return (AttributeEntry) list.remove(index); }
    public AttributeEntry set( int index, AttributeEntry ae) { return (AttributeEntry) list.set( index, ae ); }                                                                                  
    public int size( ) { return list.size(); }
    public AttributeEntry[ ] toArray() { return (AttributeEntry[]) list.toArray(); }
    public AttributeEntry[ ] toArray( AttributeEntry[ ] a) { return (AttributeEntry[]) list.toArray( a ); }

    public String getName( int i ) 
    { 
        AttributeEntry ae = (AttributeEntry) list.get(i);
        return ae.getName();
    }
    
    public String getQName( int i ) 
    { 
        return this.getName( i ); 
    }
    
    public String getLocalName( int i ) 
    {
        AttributeEntry ae = (AttributeEntry) list.get(i);
        return ae.getLocalName();
    }
    
    public String getType( int i )
    {
        AttributeEntry ae = (AttributeEntry) list.get(i);
        return ae.getType();
    }

    public String getValue( int i )
    {
        AttributeEntry ae = (AttributeEntry) list.get(i);
        return ae.getValue();
    }
    
    public int getSize( ) { return list.size(); }
    public int getLength() { return list.size(); }
    
    // Protected methods overriding AbstractList
    // protected void removeRange( int fromIndex, int toIndex) { list.removeRange( fromIndex, toIndex ); }
    // Public methods overriding Object
    public Object clone( ) 
    { 
        ParserAttributes a = new ParserAttributes();
        for ( int i=0; i < list.size(); i++ )
        {
            AttributeEntry ae = (AttributeEntry) list.get(i);
            AttributeEntry ac = new AttributeEntry();
            
            ac.setName(ae.getName().toString());
            ac.setType(ae.getType().toString());
            ac.setValue(ae.getValue().toString());
            
            a.add( ac );
        }
        a.trimToSize();
        return a;
    }
    
}
   