package com.adobe.rice.common.administration;
import com.adobe.rice.kernel.*;
import java.util.*;

public class AdministrationManager extends IceCubeManager
                                   implements Administrable
{
    // AdministrationManager is a singleton class
    private static  AdministrationManager administrator;
    private static  AdministrationProxy proxy;
    
    private boolean debugFlag = false;
       
    // on creation, create single instance   
    // FIX - thing of something intelligent to do about
    // this
    static   
    {
        try
        {
           proxy = new AdministrationProxy ();
           administrator = new AdministrationManager ();
        }
        catch (DispatcherException de)
        {
            de.printStackTrace ();
        }
    }
       
    /*
       NOTE - Visual Cafe seems to not allow inner classes
       to access protected methods
    */
    class AdministrativeRunner extends IceRunner
    {
        private IceMessage message;
        private IceMessage response;
        
        AdministrativeRunner (IceMessage message) 
                                     throws DispatcherException
        {
           super (Thread.currentThread ().getName (),
                  MessageDispatcher.instance ());
            
           this.message = message;      
        }
        
        public void run ()
        {
           IceMessage reply = null;
           
           switch (message.getAction ())
           {
              case com.adobe.rice.kernel.Constants.iceGetCatalog: 
              if (debugFlag)
              {  
                 String i = "ice-get-catalog request received <br>";
                 System.out.println (i);
                 reply = new IceMessage (message, i);
              }
              
              break;
               
              case com.adobe.rice.kernel.Constants.iceGetSubscriptionOffer:
              if (debugFlag)
              {
                 String i = "ice-get-subscriptionOffer received <br>";
                 System.out.println (i);
                 reply = new IceMessage (message, i);
              }
              
              break;
              
              case com.adobe.rice.kernel.Constants.iceAddSubscriptionOffer:
              if (debugFlag)
              {
                 String i = "ice-add-subscriptionOffer request received <br>";
                 System.out.println (i);
                 reply = new IceMessage (message, i);
              }
              
              break;
              
              case com.adobe.rice.kernel.Constants.iceRemoveSubscriptionOffer:
              if (debugFlag)
              {
                 String i = "ice-remove-subscriptionOffer request received <br>";
                 System.out.println (i);
                 reply = new IceMessage (message, i);
              }               
              
              break;
              
              case com.adobe.rice.kernel.Constants.iceAuthenticate:
              if (debugFlag)
              {
                 String i = "ice-authenication request received <br>";
                 System.out.println (i);
                 reply = new IceMessage (message, i);
              }
            
              break;
              
              case com.adobe.rice.kernel.Constants.iceNewSubscription:
              if (debugFlag)
              {
                 String i = "ice-new-subscription request received <br>";
                 System.out.println (i);
                 reply = new IceMessage (message, i);
              }
            
              break;
              
              case com.adobe.rice.kernel.Constants.iceChangeSubscription:
              if (debugFlag)
              {
                 String i = "ice-new-subscription request received <br>";
                 System.out.println (i);
                 reply = new IceMessage (message, i);
              }
            
              break;
            
              case com.adobe.rice.kernel.Constants.iceEvents:
              if (debugFlag)
              {
                 String i = "ice-events request received <br>";
                 System.out.println (i);
                 reply = new IceMessage (message, i);
              }
            
              break;
              
              // add case for send-confirmations
              
              default:
              if (debugFlag)
              {
                 String i = "unknown request received <br>";
                 System.out.println (i);
                 reply = new IceMessage (message, i);
              }
              
              break;
           }
           
           reply (reply);
        }
    }
  
    /************ body of the AdministrationManager *********/
    public Response processIceCode (int    numericCode,
                                    String messageId,
                                    String packageId,
                                    String payloadId,
                                    String phrase,
                                    String language,
                                    String text)
    {
        Response response = null;     
        
        
        return response;
    }                                


    public Response processIceNotification (int priority)
    {
        Response response = null;
        
        
        return response;
    }
    
    
    public Response sendConfirmations (String subscriptionId)
    {
        return null;
    }
    
    
    public Response getIceEvents (int    format,
                                  Date   start,
                                  Date   stop,
                                  String subscriptionId)
    {
        Response response = null;
        
        return null;   
    }
    
    
    /*************** public methods ************************/
    
    
    // AdministrationManager can be sub-classed but not
    // instanciated directly
	protected AdministrationManager () throws DispatcherException
	{
		super ("administration-manager", 
		       MessageDispatcher.instance ());
	}
	
	
	public static Administrable instance ()
    {
        return proxy;
    }
	
	
    public void finalize()
    {
        // This method is derived from class com.adobe.rice.kernel.IceCubeManager
        // to do: code goes here
    }

    public void initialize()
    {
        // This method is derived from interface com.adobe.rice.common.Manager
        // to do: code goes here
    }

    public void postFinalize()
    {
        // This method is derived from interface com.adobe.rice.common.Manager
        // to do: code goes here
    }

    public void postInitialize()
    {
        // This method is derived from interface com.adobe.rice.common.Manager
        // to do: code goes here
    }

    public void preFinalize()
    {
        // This method is derived from interface com.adobe.rice.common.Manager
        // to do: code goes here
    }

    public void preInitialize()
    {
        // This method is derived from interface com.adobe.rice.common.Manager
        // to do: code goes here
    }
    
    // NOTE: we will initially start with an iterative
    // version of the manager which implements a thread
    // on demand. This will change to a thread pool.
    public void run()
    {
       IceMessage request;
       IceMessage reply = null;
       Runnable   runner;
       
       // have to come up with an efficient method
       // shutting down the manager
       
       while (true)
       {
           try
           {
              request = (IceMessage) receive ();
              runner = new AdministrativeRunner (request);
              new Thread (null, runner, getName ()).start ();
           }
           catch (DispatcherException e)
           {
              e.printStackTrace ();
           }
       }
    }  
}