/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/asks/AskManager.java,v 1.3 2000/12/02 23:26:05 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/

package com.adobe.rice.common.asks;

//
// java imports
//
import java.util.*;
import java.io.*;
//
// icecubes imports
//
import com.adobe.rice.util.*;
import com.adobe.rice.util.time.*;
import com.adobe.rice.kernel.*;
import com.adobe.rice.common.asks.*;
import com.adobe.rice.common.XMLassembly.*;
import com.adobe.rice.common.payloadAssembly.*;
import com.adobe.rice.common.payloadAssembly.requests.*;
import com.adobe.rice.common.storage.logging.*;
import com.adobe.rice.common.transportation.*;
import com.adobe.rice.common.policies.*;

public class AskManager extends IceCubeManager
{
    private static AskManager askManager = null;
    
    private AskManager() throws DispatcherException
    {
        super("AskManager");
    }
    
    public static AskManager instance()
    {
        if ( askManager == null )
        {
            try { askManager = new AskManager(); } 
            catch ( DispatcherException de ) {}
        }
        return askManager;
    }
    // Startup Initialization Logic.
    // initially run for pre-initialization
    public void preInitialize() {}
    // run after all managers have been pre-initialized.
    public void initialize() {}	
    // run after all managers have been initialized.
    public void postInitialize() {}	

    // Running Logic.
    public void run()
    {
        //
        // $TEMP$
        //
        AskManager.instance().testAskNop();
    }

    // Shutdown Finalization Logic:
    
    // Run at shutdown to notify of pending finalization
    public void preFinalize() {}	
    // run after all managers have been pre-finalized.
    public void finalize() {}
    // run after all managers have been finalized..
    public void postFinalize() {}		
    
    private void testAskNop()
    {
	    int logLevel = ((Integer) PolicyManager.instance().getSafeSelection("LoggingLevel", new Integer( 0 ) ) ).intValue();
        AskNop                  theNop;
        StringReader            theInputReader;
        StringWriter            theOutputWriter;
        HTTPtransport           http = new HTTPtransport();
        
        int maxCount = 5;
        for ( int i = 0 ; i < maxCount; i++ )
        {
            if ( logLevel > 8 )
	            System.out.println( "Starting NOP #" + ( new Integer(i)).toString() + "!");
            
            theNop = new AskNop();
            //
            // now send the NOP
            //
            PayloadDoc payloadDoc = theNop.getPayload();
            
            String theNopPacket = payloadDoc.toXMLstring();
            
	        if ( logLevel > 8 )
	        {   // Write packet to log if really want detail!
                Object[] parms = { "AskRequest", theNopPacket };    
                TransportMessages.log(TransportMessages.get("GeneratedPacket"), parms, ImpactRange.COMMENTARY );
	        }
            // now pretend that we just received the packet.
            
            theInputReader = new StringReader( theNopPacket );
            
            theOutputWriter = new StringWriter();
            
            http.receiveRequest( theInputReader, theOutputWriter );
            
            String theNopResponse = theOutputWriter.toString();
    	    
	        if ( logLevel > 8 )
	        {   // Write packet to log if really want detail!
                Object[] parms = { "receivedPacket", theNopResponse };    
                TransportMessages.log(TransportMessages.get("ReceivedPacket"), parms, ImpactRange.COMMENTARY );
	        }
	        
	        if ( logLevel > 8 )
	            System.out.println( "Finished NOP #" + ( new Integer(i)).toString() + "\n");
	        
	        theNop = null;
                        
        }
    }
    
    //
    // test the asks
    //
    
    public static void main (String argv [])
    {
            AskManager.instance().testAskNop();
        
    }
    
    
}

