/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/asks/AskNop.java,v 1.3 2000/12/02 23:26:05 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/

package com.adobe.rice.common.asks;

//
// java imports
//
import java.util.*;
//
// icecubes imports
//
import com.adobe.rice.util.*;
import com.adobe.rice.util.time.*;
import com.adobe.rice.common.asks.*;
import com.adobe.rice.common.XMLassembly.*;
import com.adobe.rice.common.payloadAssembly.*;
import com.adobe.rice.common.payloadAssembly.requests.*;
import com.adobe.rice.common.storage.logging.*;

public class AskNop extends Ask
{
    public AskNop()
    {
        super();
        
        // An AskNop must have a payload doc.
        
        if ( this.payload == null )
        {
            /* try {  */
            this.payload = PayloadFactory.instance().get(); 
            /*
            }
            catch ( DocTypeException dte ) 
            {   // log the fact that we got an DocType execption...
                Object[] parms = { "ice-payload", "Ask nop", dte.getMessage() };    
                AskMessages.log(AskMessages.get("documentFailed"), parms, 400000000 );
            }
            catch ( ElementException ee ) 
            {   // log the fact that we got an Element execption...
                Object[] parms = { "ice-header", "ice-payload", ee.getMessage() };    
                AskMessages.log(AskMessages.get("contentInvalid"), parms, 400000000 );
            }
            catch ( XMLdocException xde ) 
            {   // log the fact that we got an XMLdoc execption...
                Object[] parms = { "ice-payload", "Ask nop", xde.getMessage() };    
                AskMessages.log(AskMessages.get("documentFailed"), parms, 400000000 );
            }
            */
        }
        
        this.addRequest();
        try { this.make(); }
        catch ( ElementException ee ) { }
    }
    
    public AskNop( String version )
    {
        super( version );
        try { this.make(); }
        catch ( ElementException ee ) {}
    }
    
    public AskNop( String version, String variant )
    {
        super( version, variant );
        try { this.make(); }
        catch ( ElementException ee ) {}
    }
    
    public void make() throws ElementException
    {
        Nop theNop = null;
        
        this.request.open();
            theNop = new Nop( this.request, this.payload.getDtd() );
            try { this.request.add( theNop ); }
            catch ( ElementException ee ) 
            { 
                // log the fact that we got an Element execption...
                Object[] parms = { "ice-nop", "ice-request", ee.getMessage() };    
                AskMessages.log(AskMessages.get("contentInvalid"), 
                    parms, 400000000 );
                throw ee; 
            }
        finally { this.request.close(); }
    }
}

