/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/catalog/Catalog.java,v 1.1.1.1 2000/09/19 19:39:44 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/

package com.adobe.rice.common.catalog;

import java.util.*;
import java.io.*;
import java.text.*;
//$JDK1.1$ import com.sun.java.util.collections.*;
import com.adobe.rice.common.storage.*;


public class Catalog 
{
    Contact contact;
    List offers;
	
    public Catalog()
    {
	contact = null;
	offers = new ArrayList( Constants.EXPECTED_OFFER_COUNT );
    }
	
    public Catalog( Contact c )
    {
	this();
	contact = c;
    }
	
    public void setOffers( List o ) { offers = o; }
    public List getOffers() { return offers; }
	
    public void setContact( Contact c ) { contact = c; }
    public Contact getContact() { return contact; }
	
	
    public String toXMLstring() throws CatalogException
    {
	String startTag = "<ice-catalog " + ">\n" ;
	String endTag = "</ice-catalog>\n";
	StringBuffer content = new StringBuffer( Constants.EXPECTED_OFFER_COUNT* Constants.EXPECTED_OFFER_LENGTH );
								  				
	if ( (offers != null) && (offers.size() > 0) )
	{
	    for ( int i = 0; i < offers.size(); i++ )
	    {
		Object o = offers.get(i);
		
		if ( o instanceof Offer )
		{
		    Offer of = (Offer) o ;
		    try { content.append( of.toXMLstring() ); }
		    catch ( OfferException e ) 
		    {
			CatalogException ce = new CatalogException( e.getMessage() );
			throw ce;
		    }
		}
		else if ( o instanceof OfferGroup )
		{
		    OfferGroup og = (OfferGroup) o;
		    try { content.append( og.toXMLstring() ); }
		    catch ( OfferException e )
		    {
			CatalogException ce = new CatalogException( e.getMessage() );
			throw ce;
		    }
		}
		else
		{
		    Object[] eargs = { contact.name };
		    String msg = MessageFormat.format( Messages.Catalog_IllegalObject, eargs );
		    CatalogException cBad = new CatalogException( msg );
		    throw cBad; 
		}
	    }
	}
	return startTag + content.toString() + endTag;
    }
}
