/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/catalog/OfferGroup.java,v 1.1.1.1 2000/09/19 19:39:44 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/

package com.adobe.rice.common.catalog;

import java.util.*;
import java.io.*;
import java.text.*;
//$JDK1.1$ import com.sun.java.util.collections.*;
import com.adobe.rice.common.storage.*;

public class OfferGroup implements Serializable
{
    private String	description;
    private List	offers;				// elements are offers or offer groups
		
    public OfferGroup()
    {
	description = "";
	offers = new ArrayList(Constants.EXPECTED_OFFER_COUNT);
    }
	
    public String toString()
    {
	String header = "OfferGroup = { ";
	StringBuffer content = new StringBuffer( Constants.EXPECTED_OFFER_LENGTH * offers.size() );
	String trailer = "}";
	Offer of = null;
	OfferGroup og = null;
		
	header += "description = \"" + description + "\"; ";
		
	if ( offers.size() > 0 )
	{
	    for ( int i = 0; i < offers.size(); i++ )
	    {
		Object o = offers.get(i);
		if ( o instanceof Offer )
		{
		    of = (Offer) o;
		    content.append( of.toString() );
		}
		else if ( o instanceof OfferGroup )
		{
		    og = (OfferGroup) o;
		    content.append( og.toString() );
		}
		else
		{
		    content.append( o.toString() );
		}
		
	    }
	}
	return header + content.toString() + trailer;
    }
	
    public String toXMLstring() throws OfferException
    {
	String startTag = "<ice-offer-group description = \"" + description + "\" >";
	StringBuffer content = new StringBuffer( Constants.EXPECTED_OFFER_LENGTH * offers.size() );
	String endTag = "</ice-offer-group>";
	Offer of = null;
	OfferGroup og = null;
	
	if ( offers.size() > 0 )
	{
	    for ( int i = 0; i < offers.size(); i++ )
	    {
		Object o = offers.get(i);
		if ( o instanceof Offer )
		{
		    of = (Offer) o;
		    content.append( of.toXMLstring() );
		}
		else if ( o instanceof OfferGroup )
		{
		    og = (OfferGroup) o;
		    content.append( og.toXMLstring() );
		}
		else
		{
		    Object[] args = { description };
		    String msg = MessageFormat.format( Messages.OfferGroup_IllegalObject, args );
		    OfferException oBad = new OfferException( msg );
		    throw oBad; 
		}
					
	    }
	}		
	return startTag + endTag;
    }
	
    public void setDescription( String d ) { description = d; }
    public String getDescription( ) { return description; }
	
    public void setOffers( List o ) { offers = o; }
    public List getOffers() { return offers; }
	
    public void appendOffers( OfferGroup og )
    {
	offers.add( og );
    }
	
    public void appendOffers( Offer o )
    {
	offers.add( o ); 
    }
}
