/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/collections/IssueElement.java,v 1.2 2000/09/25 00:46:30 bhunt Exp $

<<ICECOPYRIGHT>>
*/

/*----------------------------------------------------------------------------------------+
 |                                                                                        |
 |                              Reference Implementation of ICE                           |
 |                                                                                        |
 |                       Collections -- Issue Element Class Definition                    |
 |                                                                                        |
 +----------------------------------------------------------------------------------------*/ 

package com.adobe.rice.common.collections;

import com.adobe.rice.common.storage.logging.*;
import com.adobe.rice.common.policies.*;
import com.adobe.rice.common.*;

//$JDK1.1$ import com.sun.java.util.collections.*;
import java.util.*;

public class IssueElement 
{

    private String name;                    // name of the issue element.
    private int id;                         // number which indicates where the issue element is stored in the issue
    private int hash;                       // MD5 hash of the data, of all items if item group, etc 
    private String subscriptionElementReference;   // name of the model element that the issue element is referenced to.
    private boolean itemGroup;              // true if item group.
    private List   items;                   //  
             
    public IssueElement()
    {
        name = "";
        id = -1;
        hash = -1;   
        subscriptionElementReference = "modelElmRef";
        itemGroup = false;
        items = null; 
    }
    
    public IssueElement( String issueElementName, String referenceToModelElement )
    {
        name = issueElementName;
        id = -1;
        hash = -1;   
        subscriptionElementReference = referenceToModelElement;
        itemGroup = false;
        items = null; 
    }
    
    public String getName() { return name; }
    public void setName( String newName ) { name = newName; }
    public int getId() { return id; }
    public void setId( int newId ) { id = newId; }
    public String getSubscriptionElementReference() { return subscriptionElementReference; }
    public void setSubscriptionElementReference( String newModelElementRef ) { subscriptionElementReference = newModelElementRef; }
    public int getHash() { return hash; }
//$$FIX$$ should the item be represented as a File, a String, the hash of the file..?
    public void setItem( String fileName ) { items.add(fileName); } 
    public String getItem( int indexOfDesiredItem) { return (String)items.get(indexOfDesiredItem); }
    
    /**
    * Method that is called to indicate that all items have been added to the issue element. This
    * makes it possible to get the hash of the list of items.
    */
    public void finishIssueElement()
    {
        if (items == null)
        {
            // $LOG$ 
            // error - the list is empty - the issue element isn't functional without a list
            // indicates either a logic error or data corruption
            hash = 0;
            return;
        }
        if ( items.size() > 1 )
        {
            itemGroup = true;
        }
        hash = items.hashCode();
    }
    
    /**
    * Method that is called by deleteIssueElement to delete an issue element from issueElementArray 
    * without removing its space in the array.  This both ensures that the indeces of other elements
    * further along in issueElementArray will not be changed and that the space will be available 
    * when a new element is added into issueElementArray.
    */
    public void clearIssueElement()
    {
        name = null;//"";
        id = -1;
        hash = -1;   
        subscriptionElementReference = null;//"modelElmRef";
        itemGroup = false;
        items = null; 
    }
}