/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/collections/Package.java,v 1.1.1.1 2000/09/19 19:39:44 bhunt Exp $

<<ICECOPYRIGHT>>
*/

/*----------------------------------------------------------------------------------------+
 |                                                                                        |
 |                              Reference Implementation of ICE                           |
 |                                                                                        |
 |                          Collections -- Package Class Definition                       |
 |                                                                                        |
 +----------------------------------------------------------------------------------------*/ 

package com.adobe.rice.common.collections;

import com.adobe.rice.common.*;
import com.adobe.rice.util.ExceptionMessages;

import java.util.*;
//$JDK1.1$ import com.sun.java.util.collections.*;

public class Package
{
    private String subscriptionId;                      // tells which subscriber and collection this update is for
    private String previousState;                       // the state of the previous package sent
    private String newState;                            // the state that the new package will update to
    private ArrayList packageElements;                  // a list of the changes
    
    public Package()
    {
        subscriptionId = "";
        previousState = "";
        newState = "";
        packageElements = new ArrayList();
    }
   
    public Package( String subscriptionIdentifier, String stateBeforePackage)
    {
        subscriptionId = subscriptionIdentifier;
        previousState = stateBeforePackage;
        newState = "";
        packageElements = new ArrayList();
    }
    
    public Package( String subscriptionIdentifier, String stateBeforePackage, String stateAfterPackage )
    {
        subscriptionId = subscriptionIdentifier;
        previousState = stateBeforePackage;
        newState = stateAfterPackage;
        packageElements = new ArrayList();
    }
    
    public String getSubscriptionId() { return subscriptionId; }
    public void setSubscriptionId( String identifier ) { subscriptionId = identifier; }
    public void setPreviousState( String n ) { previousState = n; }
    public String getPreviousState() { return previousState; }
    public void setNewState( String n ) { newState = n; }
    public String getNewState() { return newState; }
 
    /**
    * Method to add a package element to the end of the packageElements array list.
    *
    * @param packageElementToAdd    The package element which is to be added at the end of packageElements.
    */
    public void setPackageElement(PackageElement packageElementToAdd)
    {
        if (packageElementToAdd != null)
            packageElements.add(packageElementToAdd);
        else
            return;
    }
    
    /**
    * Method to get a package element from the packageElements array list.
    *
    * @param index    The index of the package element in packageElements.
    */
    public PackageElement getPackageElement(int index) 
    { 
        if ( (index < 0) || (index > packageElements.size()) )
            return null;
        else 
            return (PackageElement) packageElements.get(index); 
    }   
    
    /**
    * Method to return the number of package elements in packageElements.
    */
    public int getPackageLength() 
    { 
        return (packageElements.size()); 
    } 
    
    /**
    * Method to trim packageElements so that when the package is sent, the array list will not be 
    * excessively long.
    */
    public void trimPackage()
    {
        packageElements.trimToSize();
    }
}