/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/collections/PackageSequenceId.java,v 1.2 2000/09/25 00:46:30 bhunt Exp $

<<ICECOPYRIGHT>>
*/

/*----------------------------------------------------------------------------------------+
 |                                                                                        |
 |                              Reference Implementation of ICE                           |
 |                                                                                        |
 |               Collections -- Package Sequence Identifier Class Definition              |
 |                                                                                        |
 +----------------------------------------------------------------------------------------*/ 

package com.adobe.rice.common.collections;

import com.adobe.rice.common.*;
import com.adobe.rice.util.ExceptionMessages;
import com.adobe.rice.util.time.*;

import java.util.*;
//$JDK1.1$ import com.sun.java.util.collections.*;

public class PackageSequenceId 
{
    private static int seqNum = 0;
    private static Integer seqNumber = new Integer(0);       // Class wide variable containing a unique sequence number
    
    private String roleId;                  // The current syndicator or subscriber id depending on the role.
    private String date;                    // The date the PSId was created.
    private String seq;                     // The sequence number
    
    public PackageSequenceId()
    {
        synchronized ( seqNumber )
        { 
            seqNum++;
            seqNumber = new Integer( seqNum);
            seq = seqNumber.toString();
        }
        
        IceDate iceDate = new IceDate();
        
        date = iceDate.toString();
        
        //$FIX$ Make sure that the appropriate role gets inserted here.
        
        roleId = (String) Tray.getPolicyManager().getSelection("Role");
        
    }
    
    public PackageSequenceId( String sid, String dt, String sq )
    {
        roleId = sid;
        date = dt;
        seq = sq;
    }
    
    public String getRoleId() { return roleId; }
    public void setRoleId( String n ) { roleId = n; }
    public String get() { return roleId + date + seq ; }
    public String toString() { return this.get(); }
    
    public String getDate() { return date; }
    public String getSeq() { return seq; }
    
    public String getPackageSequenceId()
    {
        String PSId = roleId+date+seq;
        return PSId;
    }
    
}