/*
 As of 2000/08/16 18:08:09, this method works properly
*/
// this is to test that it is actually possible to make an "Issue".  
//   it ensures that an issue element is only added to issueElementArray when it is not already in the Array
// if you would like to test just checking "checklist" or "BitVector", it would be better to use iceCheck
// if you would like to test just stateTable, it would be better to use iceTable
// if you would like to test packagePreparation, it would be better to use icePackage
// if you would like to test generateUpdateList, it would be better to use icePkgList
// if you would like to test makeUpdate, it would be better to use iceUpdate
// if you would like to test makeUpdate and unwrapPackage, or want an example of how to create, 
//   fill, and update a collection from "scratch," use iceTest

// output: issueElementMark = 0
//         issueElementMark = 1
//         final IssueElementMark = 1
//         issue 0 is finished and has been added to 'issues'.
//         issueElementMark = 2
//         issueElementMark = 2
//         final IssueElementMark = 2
//         issue 1 is finished and has been added to 'issues'.
//         issueElementMark = 3
//         issueElementMark = 3
//         final IssueElementMark = 3
//         issue 2 is finished and has been added to 'issues'.
//         status of name00, hash = 0, id = 0, MER = ref0
//         in issue 0 is 1
//         in issue 1 is 3
//         in issue 2 is 2
//         status of name70, hash = 0, id = 1, MER = ref7
//         in issue 0 is 1
//         in issue 1 is 1
//         in issue 2 is 1
//         status of name10, hash = 0, id = 2, MER = ref1
//         in issue 0 is 0
//         in issue 1 is 1
//         in issue 2 is 3
//         status of name20, hash = 0, id = 3, MER = ref2
//         in issue 0 is 0
//         in issue 1 is 0
//         in issue 2 is 1
//         done



package com.adobe.rice.common.collections;
import java.util.*;
import java.io.*;

public class iceIssue
{
    public static void main( String[] args )
    { 
        Collection bob = new Collection();
        for (int is = 0; is<3; is++)
        {
            Model model = bob.getModel();
            for ( int count = 0; count < 2; count++ )
            {
                String nm = "name"+is+count;
                String ref = "ref"+(is+count);
                if ((count) == 1)
                {
                    nm = "name"+7+is;
                    ref = "ref"+7;
                }
                SubscriptionElement se = new SubscriptionElement(ref+1, nm);
                model.setSubscriptionElement(se);
                IssueElement iElement = new IssueElement(nm, ref );
                iElement.finishIssueElement();
                bob.setIssueElement(iElement);
                System.out.println( "issueElementMark = " + bob.getIssueElementMark() );
            } // end for
        
            System.out.println( "final IssueElementMark = " + bob.getIssueElementMark() );
            Issue jules = new Issue();
            bob.issueDone( jules ); 
            
            Issue inIssues = (Issue) bob.getIssue( bob.getCurrentIssue() );
            if ( inIssues.getFinished() == true )
                System.out.println( "issue " + inIssues.getId()+ " is finished and has been added to 'issues'." );        
        } // end for
        
        Issue currentIssue = bob.getIssue( bob.getCurrentIssue() );
        int numIssueElements = currentIssue.getElementCount();
        for (int index=0; index<=(numIssueElements); index++) 
        {
            IssueElement jen = bob.getIssueElement(index);
            System.out.println("status of " + jen.getName()+", hash = "+jen.getHash()+", id = "+jen.getId()+", SER = "+jen.getSubscriptionElementReference());
            for (int count = 0; count <= currentIssue.getId(); count++)
            {
                Issue issue = bob.getIssue( count );
                System.out.println("   in issue " + issue.getId() + " is " + issue.getElementStatus(index) );
            }
        } // end for

        System.out.print( "done" );
        return;
    }
}
                  