/*
 As of 2000/08/24 14:28:09, this method works properly
*/

// this tests generateUpdateList(at the bottom of the program)
// if you would like to test just checklist or BitVector, it would be better to use iceCheck
// if you would like to test just stateTable, it would be better to use iceTable
// if you would like to test just issueElementArray, it would be better to use iceIssue
// if you would like to test packagePreparation, it would be better to use icePackage
// if you would like to test makeUpdate, it would be better to use iceUpdate
// if you would like to test makeUpdate and unwrapPackage, or want an example of how to create, 
//   fill, and update a collection from "scratch," use iceTest


// NOTE: the states should vary a tiny bit, due to the fact that they contain the current date, 
//   but the last digit should match (the last digit = issueId+1 )
// output: issueElementMark = 0
//         issueElementMark = 1
//         final IssueElementMark = 1
//         issue 0 is finished and has been added to 'issues'.
//         issueElementMark = 2
//         issueElementMark = 2
//         final IssueElementMark = 2
//         issue 1 is finished and has been added to 'issues'.
//         issueElementMark = 3
//         issueElementMark = 3
//         final IssueElementMark = 3
//         issue 2 is finished and has been added to 'issues'.
//         status of name00, hash = 0, id = 0, MER = ref0
//         in issue 0 is 1
//         in issue 1 is 3
//         in issue 2 is 2
//         status of name70, hash = 0, id = 1, MER = ref7
//         in issue 0 is 1
//         in issue 1 is 1
//         in issue 2 is 1
//         status of name10, hash = 0, id = 2, MER = ref1
//         in issue 0 is 0
//         in issue 1 is 1
//         in issue 2 is 3
//         status of name20, hash = 0, id = 3, MER = ref2
//         in issue 0 is 0
//         in issue 1 is 0
//         in issue 2 is 1
//         number of package elements in the package list: 4
//         previous state: ASHAMBLE2000-08-232
//         new state: ASHAMBLE2000-08-233
//         start issue2
//         Remove 2                 // the 2 refers to the issue element's index in issueElementArray
//         Add name20
//         end issue2
//         done
 

package com.adobe.rice.common.collections;
import java.util.*;
import java.io.*;

public class icePkgList
{
    public static void main( String[] args )
    { 
        Collection bob = new Collection();
        Model model = bob.getModel();
        for (int is = 0; is<3; is++)
        {
            
            for ( int count = 0; count < 2; count++ )
            {
                String nm = "name"+is+count;
                String ref = "ref"+(is+count);
                if ((count) == 1)
                {
                    nm = "name"+7+is;
                    ref = "ref"+7;
                }
                SubscriptionElement se = new SubscriptionElement(ref, nm);
                model.setSubscriptionElement(se);
                IssueElement iElement = new IssueElement(nm, ref );
                iElement.finishIssueElement();
                bob.setIssueElement(iElement);
                System.out.println( "issueElementMark = " + bob.getIssueElementMark() );
            } // end for
        
            System.out.println( "final IssueElementMark = " + bob.getIssueElementMark() );
            Issue jules = new Issue("issue"+is);
            bob.issueDone( jules ); 
            
            Issue inIssues = (Issue) bob.getIssue( bob.getCurrentIssue() );
            if ( inIssues.getFinished() == true )
                System.out.println( "issue " + inIssues.getId()+ " is finished and has been added to 'issues'." );        
        } // end for
        
        Issue currentIssue = bob.getIssue( bob.getCurrentIssue() );
        int numIssueElements = currentIssue.getElementCount();
        for (int index=0; index<=(numIssueElements); index++) 
        {
            IssueElement jen = bob.getIssueElement(index);
            System.out.println("status of " + jen.getName()+", hash = "+jen.getHash()+", id = "+jen.getId()+", SER = "+jen.getSubscriptionElementReference());
            for (int count = 0; count <= currentIssue.getId(); count++)
            {
                Issue issue = bob.getIssue( count );
                System.out.println("   in issue " + issue.getId() + " is " + issue.getElementStatus(index) );
            }
        } // end for
        
  // this part actually deals with generateUpdateList
        String subscId = "subscriptionId";
        int subState = (currentIssue.getId());  // try 0, 1, 2, 3; 3 should come out w/o an update nec.
        Issue from = bob.getIssue(subState-1);
        Issue to = bob.getIssue(bob.getCurrentIssue());
        Package pkgList= new Package();
        bob.generateUpdateList( from, to, pkgList ); 
        // to double check that the elements are being treated correctly, put println's in generateUpdateList
        System.out.println("number of package elements in the package list: "+pkgList.getPackageLength());
        System.out.println("previous state: "+pkgList.getPreviousState());
        System.out.println("new state: "+pkgList.getNewState());
        for (int count=0; count<pkgList.getPackageLength(); count++)
        {
            PackageElement pe = pkgList.getPackageElement(count);
            int axn = pe.getAction();
            if (axn == 1)
            {
                System.out.print("Add ");
                IssueElement elm = pe.getElement(); 
                System.out.println(elm.getName());
            }
            else if (axn == 2)
            {
                System.out.println("Remove "+pe.getId()); 
            }
            else if (axn == 0)
            {
                System.out.println("start "+pe.getIssueName());
            }     
            else if (axn == 3)
            {
                System.out.println("end " +pe.getIssueName());
            }  
        }
        System.out.println( "done" );
        return;
    }
}