/*
 As of 2000/8/25, this method works properly
*/
// this is to show that makeUpdate and unwrapPackage work properly. it is also an example 
//   of how to create, fill, and update a collection from "scratch."
// if you would like to test just makeUpdate, it would be better to use iceUpdate
// if you would like to test just stateTable, it would be better to use iceTable
// if you would like to test just packagePreparation, it would be better to use icePackage
// if you would like to test just generateUpdateList, it would be better to use icePkgList
// if you would like to test just issueElementArray, it would be better to use iceIssue
// if you would like to test checklist or BitVector, use iceCheck

// NOTE: the issue id changes when the issue is added to another collection, but the state
//   still refers to the same issue as it did in the original collection
// output: in collection bob:
//         issue 0 of state ASHAMBLE2000-08-241
//         issue element SE00 status 1
//         issue 1 of state ASHAMBLE2000-08-242
//         issue element IE00 status 3
//         issue element IE10 status 1
//         issue element IE11 status 1
//         issue 2 of state ASHAMBLE2000-08-243
//         issue element IE00 status 2
//         issue element IE10 status 3
//         issue element IE11 status 3
//         issue element IE20 status 1
//         issue element IE21 status 1
//         issue element IE22 status 1
// 
//         contents of update:
//         before package: ICE-INITIAL
//         start issue issue0
//         Add IE00
//         end issue issue0
//         after package: ASHAMBLE2000-08-241
// 
//         update:
//         package from ICE-INITIAL to ASHAMBLE2000-08-241 successful!
// 
//         in collection betty:
//         issue 0 of state ASHAMBLE2000-08-241
//         issue element IE00 status 1
// 
//         contents of update:
//         before package: ASHAMBLE2000-08-241
//         start issue issue1
//         Remove 0
//         Add IE10
//         after package: ASHAMBLE2000-08-241a
//         before package: ASHAMBLE2000-08-241a
//         Add IE11
//         end issue issue1
//         after package: ASHAMBLE2000-08-242
// 
//         update:
//         package from ASHAMBLE2000-08-241 to ASHAMBLE2000-08-241a successful!
//         package from ASHAMBLE2000-08-241a to ASHAMBLE2000-08-242 successful!
// 
//         in collection betty:
//         subscription 0 of state ASHAMBLE2000-08-242
//         issue element null status 0
//         issue element IE10 status 1
//         issue element IE11 status 1
// 
//         contents of update:
//         before package: ASHAMBLE2000-08-242
//         start issue issue2
//         Remove 1
//         Remove 2
//         Add IE20
//         after package: ASHAMBLE2000-08-242a
//         before package: ASHAMBLE2000-08-242a
//         Add IE21
//         after package: ASHAMBLE2000-08-242ab
//         before package: ASHAMBLE2000-08-242ab
//         Add IE22
//         end issue issue2
//         after package: ASHAMBLE2000-08-243
// 
//         update:
//         package from ASHAMBLE2000-08-242 to ASHAMBLE2000-08-242a successful!
//         package from ASHAMBLE2000-08-242a to ASHAMBLE2000-08-242ab successful!
//         package from ASHAMBLE2000-08-242ab to ASHAMBLE2000-08-243 successful!
// 
//         in collection betty:
//         issue 0 of state ASHAMBLE2000-08-243
//         issue element null status 0
//         issue element null status 0
//         issue element null status 0
//         issue element IE20 status 1
//         issue element IE21 status 1
//         issue element IE22 status 1
//         done


 
package com.adobe.rice.common.collections;
import com.adobe.rice.kernel.*;
import java.util.*;
import java.io.*;

public class iceTest
{
    public static void main( String[] args )
    { 
   // SYND:
       try
       {
       // first, initialize the collection manager (?)
        CollectionManager collectionManager = new CollectionManager();
        
       // then create a collection
        String collectionName = "bob";
        Collection bob = collectionManager.createCollection( collectionName );
        collectionManager.setNameTable(bob.getName(), bob);
        
       // then fill the collection 
        fillCollection(bob);
       
       // sign a subscriber up by assigning them a subscriptionId
        String subscriptionId = "subscriber";
        collectionManager.setSubscriptionTable(subscriptionId, bob);
    
   // SUB:
    // create a new collection manager from scratch
       
       // first, initialize the collection manager (?)
        CollectionManager clxnMan = new CollectionManager();
        
       // then create a collection
        String clxnName = "betty";
        Collection betty = clxnMan.createCollection( clxnName );
        clxnMan.setNameTable(betty.getName(), betty);
        
       // be sure the "subscriber is subscribed to the collection
        clxnMan.setSubscriptionTable(subscriptionId, betty);
       
       // put the model in
        Model model = betty.getModel();        
        int numberOfSubscriptionElementsDesired = 3;
        for (int count = 0; count < numberOfSubscriptionElementsDesired; count++)       
        {
            String nameOfElement = "SE"+count;
            String nameOfItem = "name"+count;
            SubscriptionElement se = makeSubscriptionElement( nameOfElement, nameOfItem );
           // if so desired, more items can be added to me by using me.setItem(name)
            model.setSubscriptionElement( se );
        } // end for
        
        while ( ! ( (betty.getCurrentState()).equals(bob.getCurrentState()) ) )
        {
     // SYND:
           // make an update for the subscriber
             
           // get the current state of the subscriber 
            String currentSubscriberState = betty.getCurrentState();
            
           // test the currentSubscriberState against those in the subscriptionArchive, to 
           // be sure that the subscriber does not already have an update available.
           // make the update, store one copy in subscriptionArchive for future reference
            ArrayList update = collectionManager.makeUpdate(subscriptionId, currentSubscriberState);
        
        if (update == null)
        {
            System.out.println("no package necc");
            return;
        }
           // print out the results of the update
            System.out.println("");
            System.out.println("contents of update:");
            printUpdate(update);
            
     // SUB:
            System.out.println("");
            System.out.println("update:");
           
           // get the update for this new collection
            for( int index = 0; index<update.size(); index++)
            {
                Package pack = (Package)update.get(index);
                boolean successful = clxnMan.unwrapPackage( pack );
                if (successful == true )
                {
                    System.out.print("package from "+pack.getPreviousState()+ " to ");
                    System.out.println(pack.getNewState()+" successful!");
                }
                else 
                {
                    System.out.println("something went wrong:");
                    System.out.println("   package state or subsciption type didnt match");
                    System.out.println("aborted -> done");
                    return;
                }
            } // end for
            
           // print out the new issue to be sure it's correct
            Issue newlyUpdated = betty.getIssue(betty.getCurrentIssue());
            System.out.println();
            System.out.println("in collection "+betty.getName()+":");
            printIssue(betty, newlyUpdated);
        } // end while
        
        System.out.println("done");
       }
       catch (DispatcherException e)
       {
           e.printStackTrace ();
       }
    }
    
    /*
    * Method to fill up the given collection
    */
    public static void fillCollection(Collection bob)
    {
       // fill in the model with subscription elements
        Model model = bob.getModel();        
        int numberOfSubscriptionElementsDesired = 3;
        for (int count = 0; count < numberOfSubscriptionElementsDesired; count++)       
        {
            String nameOfElement = "SE"+count;
            String nameOfItem = "name"+count;
            SubscriptionElement se = makeSubscriptionElement( nameOfElement, nameOfItem );
           // if so desired, more items can be added to me by using me.setItem(name)
            model.setSubscriptionElement( se );
        } // end for
        
       // make issues 
        int numberOfIssuesDesired = 3;
        System.out.println("in collection "+bob.getName()+":");      
        for(int issueNumber = 0; issueNumber < numberOfIssuesDesired; issueNumber++)
        {
           // create an issue
            String issueName = "issue"+issueNumber;
            Issue issue = new Issue(issueName);
        
           // create issue elements for the new issue
            int numberOfIssueElementsDesired = issueNumber+1;
            for (int count = 0; count < numberOfIssueElementsDesired; count++)
            {
                String nameOfElement = "IE"+issueNumber+count;
                String nameOfItem = "name"+count;
                String subscriptionElement = "SE0";
                IssueElement ie = makeIssueElement( nameOfElement, subscriptionElement, nameOfItem, issueNumber, bob);
                 // if so desired, more items can be added to me by using ie.setItem(name)
                bob.setIssueElement(ie);
            } // end for
           // when all issue elements for this issue have been created, finish the issue
            bob.issueDone(issue);
            
           // print to double check
            printIssue(bob, issue);
        }
    }
    
    
    /*
    * Method to create and fill a SubscriptionElement
    */
    public static SubscriptionElement makeSubscriptionElement(String subscriptionElementName, String subscriptionItem)
    {
        SubscriptionElement se = new SubscriptionElement(subscriptionElementName, subscriptionItem);
        return se;
    }
    
    /*
    * Method to create and fill an issue Element
    */
    public static IssueElement makeIssueElement( String issueElementName, String subscriptionElementRef, String issueItem, int count, Collection clxn)
    {
        IssueElement iss = new IssueElement(issueElementName, subscriptionElementRef+count);
        for(int numOfItems=0; numOfItems<=count; numOfItems++)
            iss.setItem(issueItem);
        iss.finishIssueElement();
        return iss;
    }
    
    /*
    * Method to print the contents of an Issue
    */
    public static void printIssue( Collection clxn, Issue issue)
    {
        System.out.println("issue "+issue.getId()+" of state "+issue.getState());
        
        for (int count=0; count<=clxn.getIssueElementMark(); count++)
        {
            IssueElement ie = clxn.getIssueElement(count);
            System.out.print("  issue element "+ie.getName());
            System.out.println(" status "+issue.getElementStatus(count));
        }
    }
    
    /*
    * Method to print out the contents of an update
    */
    public static void printUpdate(ArrayList update)
    {
        for( int count = 0; count<update.size(); count++)
        {
            Package pkg = (Package)update.get(count);
            System.out.println("before package: "+pkg.getPreviousState());
            for(int index = 0; index<pkg.getPackageLength(); index++)
            {
                PackageElement pkgE = pkg.getPackageElement(index);
                int axn = pkgE.getAction();
                if (axn == 1)
                {
                    System.out.print("Add ");
                    IssueElement elm = pkgE.getElement(); 
                    System.out.println(elm.getName());
                }
                else if (axn == 2)
                {
                    System.out.print("Remove ");
                    System.out.println(pkgE.getId());
                }
                else if (axn == 0)
                {
                    System.out.println("start issue "+pkgE.getIssueName());
                }     
                else if (axn == 3)
                {
                    System.out.println("end issue " +pkgE.getIssueName());
                }  
            }
            System.out.println("after package: "+pkg.getNewState());
        }
    }
    
}