/*
$Log: Application.java,v $
Revision 1.2  2000/10/26 00:03:30  andrewf
added documentation and copyright

$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/negotiation/Application.java,v 1.2 2000/10/26 00:03:30 andrewf Exp $
$Author: andrewf $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org
*/


// Application is the class that allows Negotiation objects
// access to the public internal state of that application
// the ICE Processor is embedded in. 
//
// To be added ApplicationProxy - prevent the ICE processor
// from altering public state
//
// <dl>
// <dt>Object get (String key) </dt>
//     <dd> get returns an value of type object associated 
//          with key. Null is returned if the object does
//          not exist. </dd>
//     
// <dt>void set (String key, Object value) </dt>
//     <dd> associate key with value. Note is the application
//          that calls this method, not the ICE processor </dd>
// </dt>

package com.adobe.rice.common.negotiation;
import java.util.*;

public class Application
{  
    private HashMap table;
    
    public Application ()
    {
       table = new HashMap ();   
    }

    public Application (String [] keys, Object [] values)
    {
        for (int n = 0 ; n < keys.length ; n++)
        {
            table.put (keys[n], values);
        }
    }
    
 
    public Object get (String key)
    {
        return table.get (key);   
    }
    
    public void set (String key, Object value)
    {
        table.put (key, value);   
    }
}
