/*
$Log: IceSession.java,v $
Revision 1.3  2000/11/21 02:35:27  andrewf
Changes

Revision 1.2  2000/10/26 00:03:30  andrewf
added documentation and copyright

$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/negotiation/IceSession.java,v 1.3 2000/11/21 02:35:27 andrewf Exp $
$Author: andrewf $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org
*/


package com.adobe.rice.common.negotiation;
import java.util.*;

public class IceSession implements Sessonable
{
    private long     startTime = 0;
    private long     round = 0;
    private String   sessionId;
    private HashMap  table;
    private int      improvedCount;
    
    /*
       note time is in milliseconds 
    */
    public IceSession ()
    {
        
    }
    
    public IceSession (String  sessionId,
                       long    round,
                       long    startTime,
                       HashMap initialMap)
    {
       this.sessionId = sessionId;
       table = new HashMap (initialMap);
       this.round = round;
       this.startTime = startTime;
       setImprovedCount (0);
    }
      
    public IceSession (String sessionId)
    {
       this.sessionId = sessionId;
       table = new HashMap ();
       this.round = 0;
       setImprovedCount (0);
       this.startTime = System.currentTimeMillis();
    }                    
                                           
    public long getRound ()
    {
        return round;
    }
    
    public void incrementRound ()
    {
        ++round;
    }
    
    public int getImprovedCount ()
    {
        return improvedCount;
    }
    
    public void setImprovedCount (int newCount)
    {
        improvedCount = newCount;
    }
    
    public long getLapsedTime ()
    {
        return (System.currentTimeMillis() * 1000) - startTime;
    }
    
    public Object get (String key)
    {
        return table.get (key);    
    }
    
    public void set (String key, Object value)
    {
        table.put (key, value);   
    }
    
    public String toString ()
    {
        return "Session Id: " + 
               sessionId + " round: " + 
               getRound () + 
               " lapsed Time: " + 
               getLapsedTime ();   
    }
}
