/*
$Log: Negotiable.java,v $
Revision 1.4  2000/11/22 00:46:33  andrewf
Changed IceNegotiable to Negotiable

Revision 1.3  2000/10/26 00:03:31  andrewf
added documentation and copyright

$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/negotiation/Negotiable.java,v 1.4 2000/11/22 00:46:33 andrewf Exp $
$Author: andrewf $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org
*/


package com.adobe.rice.common.negotiation;

//
//  Negotiable interface version
//

public interface Negotiable
{
    final         static int ACCEPT = 1;
    final         static int NEGOTIATE = 2;
    final         static int UNKNOWN = 0;
    final         static int REQUIRE = 3;
    final         static int REJECT = 4;
    final         static int ADVISE = 100;       // internal
    final         static int NOPROPOSAL = 101;   // internal
    final         static int OK = 200;
    final         static int CONFIRMED = 201;
    final         static int COUNTER_PROPOSAL = 441; 
    final         static int SORRY = 440;
    final         static int INVALID = 457;      //bad counter
    final         static int RENEGOTIATION = 458;
    final         static int IMPASSE_LIMIT = 1;  
    
    void          accept (Negotiable sender) throws InternalError;
    boolean       isAcceptable (Negotiable sender) throws OutOfRange;
    boolean       isAccepted ();
    void          accepted ();
    Negotiable    negotiate (Negotiable sender) throws 
                            Sorry,OutOfRange,InternalError;
    boolean       isNegotiable ();
    Negotiable    propose (Negotiable sender) throws InternalError;
    void          reject (int errorStatus);
    boolean       isRejected ();
    boolean       isRequired ();

//  July 24th additions    
    
    Object        Application (String key);
    Object        Session (String key);
    boolean       isError ();
    int           getErrorStatus ();
    
//  november 21 addition
    String        getName ();
}