/*
$Log: OfferStrategy.java,v $
Revision 1.3  2000/11/22 00:46:33  andrewf
Changed IceNegotiable to Negotiable

Revision 1.2  2000/10/26 00:03:31  andrewf
added documentation and copyright

$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/negotiation/OfferStrategy.java,v 1.3 2000/11/22 00:46:33 andrewf Exp $
$Author: andrewf $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org
*/


package com.adobe.rice.common.negotiation;

/*
  TODO: should have IcePolicies implement an interface
  rather than inherit. Parameter policies and offer
  policies are not the same.
*/

public abstract class OfferStrategy extends NegotiationStrategy
{  
    public abstract boolean isAcceptable (Negotiable sender,
                                          Negotiable receiver);
    
    // proceed () is the method that allows for user
    // defined pre-condition tests
    public boolean  proceed (Negotiable sender,
                             Negotiable receiver)
    {
        return true;    
    }                                      
                                                                                
    public abstract Negotiable propose (Negotiable sender,
                                        Negotiable receiver);
    
    public abstract Negotiable negotiate (Negotiable sender,
                                          Negotiable receiver)
                    throws InternalError; 
    
    // protocol canProceed () checks pre-conditions. ResolveImpasse
    // provides logic to deal with impasses and other application
    // specific pre-condition tests
    public abstract Offer resolveImpasse (Negotiable sender,
                                          Negotiable receiver)
                                          throws InternalError;
                                                 
    // post-condition logic allowing application to override
    // decisions made by the framework's algorithm
    public abstract Negotiable ratify (Negotiable sender,
                                       Negotiable receiver)
                                       throws InternalError;

    public abstract void reorder (Negotiable receiver);
}