/*
$Log: TimeEnum.java,v $
Revision 1.3  2000/11/20 21:26:12  andrewf
some work on changing parameters

Revision 1.2  2000/10/26 00:03:32  andrewf
added documentation and copyright

$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/negotiation/TimeEnum.java,v 1.3 2000/11/20 21:26:12 andrewf Exp $
$Author: andrewf $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org
*/


package com.adobe.rice.common.negotiation;
import java.util.*;

public class TimeEnum extends TimeSet
{
    private SortedSet set;
    private int selection = -1;
    
    /*************** constructors ********************/
    
	public TimeEnum (Collection set, 
                     int selection)                                                  
    { 
	   setSet (set);
	   setSelection (selection);
    }
	
	/**************** private methods ****************/
	
	private boolean isValidSelection (Set defaults,
                                      int selection)
    {
       boolean result = false;
       int count = defaults.size ();
       
       if (selection > 0)
       {
          result = (selection == count) ? true : false;
       }
       else if (selection == Setiable.zero_or_more)
       {
          result = (count >= 0) ? true : false; 
       }
       else if (selection == Setiable.zero_or_one)
       {
          result = (count == 0 || count == 1) ? true : false;
       }
       else if (selection == Setiable.one_or_more)
       {
          result = (count >= 1) ? true : false;
       }
       else 
       {
          // perhaps an exception should be thrown 
          result = false;
       }   
       return result;
    }
	
    private Set getSet ()
    {
        return set;
    }
    
    private void setSet (Collection newSet)
    {
        set = new TreeSet (newSet);   
    }    
    
    private void setSelection (int newSelection)
    {
        selection = newSelection;
    }
    
    public int getSelection ()
    {
        return selection;
    }
    
    /******************** public methods *******************/
    public boolean equals (Object operand)
    {
        return (operand instanceof TimeEnum &&
                getSelection () == ((TimeEnum) operand).getSelection () &&
                getSet ().equals (((TimeEnum) operand).getSet ()));
    }
    
    public String toString() 
    {	
        return getSet ().toString () + " " +
               getSelection ();
    } 
    
    public int rangeSize () 
    {
	   return (int) set.size ();
    }
 
    public boolean in (Set values) 
    { 
        return isValidSelection (values, selection) 
               && set.containsAll(values);
    }
    
    // re-visit
    public Date next (Date value) 
    {
	   throw new UnImplementedException ();
    }
   
    // re-visit
    public Date previous (Date value) 
    {
       throw new UnImplementedException ();
    }
    
    public Date minimum ()
    {
        return (Date) set.first();
    }
    
    public Date maximum ()
    {
        return (Date) set.last();
    }
    
    
    public static void main (String argv[])
    {
           
        
    }
}