package com.adobe.rice.common.negotiation.tests;
import com.adobe.rice.common.negotiation.*;
import com.adobe.rice.common.negotiation.InternalError;

//  EchoPolicy is a test IcePolicy
//  it "echos" back whatever is sent to it

public class EchoPolicy extends NegotiationStrategy
{   
    public boolean isAcceptable (Negotiable sender,
                                 Negotiable receiver)
    {
        Parameter s = (Parameter) sender;
        Parameter r = (Parameter) receiver;
        
        return r.getDefaultValues ().equals (s.getDefaultValues ());  
    }
                                          
    public Negotiable propose (Negotiable sender,
                               Negotiable receiver)
    {
        Parameter s = (Parameter) sender;
        Parameter r = (Parameter) receiver;
        
        // just copy the sender's defaultValues and range
        r.set (s);
        return r;
    }
    
    public Negotiable negotiate (Negotiable sender,
                                 Negotiable receiver)
                                 throws InternalError
    {
         if (isAcceptable (sender, receiver))
         {
            // receiver accepts the sender and
            // returns
            receiver.accept (sender);
         }
         else
         {
            // receiver echoes the sender's values
            receiver = propose (sender, receiver);
         }
        
         return receiver;
    }           
    
    //
    // UNIT TEST
    //
    public static void main (String argv[])
    {
        
        
    }
}