package com.adobe.rice.common.negotiation.tests;
import com.adobe.rice.common.negotiation.*;
import java.util.*;
import java.lang.*;
import java.math.*;


public class NumericParameterTester
{
    public static String buildParameterString (String min,
                                               String max,
                                               String precision)
    {
         BigDecimal r = new BigDecimal (0);
         BigDecimal minimum = new BigDecimal (min);
         BigDecimal maximum = new BigDecimal (max);
         BigDecimal p = new BigDecimal (precision);
         StringBuffer result = new StringBuffer (1024);
         
         while (minimum.compareTo (maximum) < 0)
         {
             minimum = minimum.add (p);
             result.append(" ");
             result.append(minimum.toString ());
         }
         
         return result.toString ();
    }

    
    public static boolean setiableTest2 (NumericParameter parameter)
    {
        boolean result;
        boolean testResult = false;
        NumericIceValue  vResult;   
        double           dResult;
        int              iResult;
          
        System.out.println ("Testing Set functions");
       
        result = parameter.in (new NumericIceValue(10));
        System.out.print ("parameter.in (10) should be true -> " + result);
        if (result == true)
        { 
           System.out.println ("[PASSED]");
        }
        else
        {
           System.out.println ("[FAILED]");
        }
       
        result = parameter.in ((new NumericIceValue(30)));
        System.out.print ("parameter.in (30) should be true -> " + result);
        if (result == true)
        {
           System.out.println ("[PASSED]");
        }
        else
        {
           System.out.println ("[FAILED]");
        }
       
        result = parameter.in ((new NumericIceValue(50)));
        System.out.print ("parameter.in (50) should be false -> " + result);
        if (result == false)
        {
           System.out.println ("[PASSED]");
        }
        else
        {
           System.out.println ("[FAILED]");
        }
       
        result = parameter.in ((new NumericIceValue(9.999999)));
        System.out.print ("parameter.in (10) should be false -> " + result);
        if (result == false)
        {
           System.out.println ("[PASSED]");
        }
        else
        { 
           System.out.println ("[FAILED]");
        }
       
        dResult = parameter.count ();
        System.out.print ("parameter.count should be 201 -> " + dResult);
        if (dResult == 201)
        {
           System.out.println ("[PASSED]");
        }
        else
        {
           System.out.println ("[FAILED]");
        }
        
        vResult = (NumericIceValue) parameter.minimum ();
        System.out.print ("parameter.minimum () should be 10.0 -> " + vResult);
        if (vResult.getIceValue () == 10)
        {
           System.out.println ("[PASSED]");
        }
        else
        {
           System.out.println ("[FAILED]");
        }
	     
	    vResult = (NumericIceValue) parameter.maximum ();
        System.out.print ("parameter.maximum () should be 30 -> " + vResult);
        if (vResult.getIceValue () == 30)
        {
           System.out.println ("[PASSED]");
        }
        else
        {
           System.out.println ("[FAILED]");
        }
	  
        vResult = (NumericIceValue) parameter.next (new NumericIceValue (29.9));
        System.out.print ("parameter.next () should be 30.0 -> " + vResult);
        if (vResult.getIceValue () == 30)
        {
           System.out.println ("[PASSED]");
        }
        else
        {
           System.out.println ("[FAILED]");
        }
        
        vResult = (NumericIceValue) parameter.next (new NumericIceValue (30));
        System.out.print ("parameter.next (30.0) should be NaN -> " + vResult);
        if (Double.isNaN (vResult.getIceValue ()))
        {
           System.out.println ("[PASSED]");
        }
        else
        {
           System.out.println ("[FAILED]");
        }   
           
        vResult = (NumericIceValue) parameter.previous (new NumericIceValue (10.1));
        System.out.print ("parameter.previous (10.1) should be 10.0 -> " + vResult);
        if (vResult.getIceValue () == 10)
        {
           System.out.println ("[PASSED]");
        }
        else
        {
           System.out.println ("[FAILED]");
        }
       
        vResult = (NumericIceValue) parameter.previous (new NumericIceValue (10));
        System.out.print ("parameter.previous (10) should be NaN -> " + vResult);
        if (Double.isNaN (vResult.getIceValue ()))
        {
           System.out.println ("[PASSED]");
        }
        else
        {
           System.out.println ("[FAILED]");
        }
       
        return testResult;
    }  
    

    public static boolean setiableTest (NumericParameter parameter)
    {
        boolean result;
        boolean testResult = false;
        NumericIceValue  vResult;   
        double           dResult;
        int              iResult;
          
        System.out.println ("Testing Set functions");
       
        result = parameter.in (new NumericIceValue(10));
        System.out.print ("parameter.in (10) should be true -> " + result);
        if (result == true)
        { 
           System.out.println ("[PASSED]");
        }
        else
        {
           System.out.println ("[FAILED]");
        }
       
        result = parameter.in ((new NumericIceValue(30)));
        System.out.print ("parameter.in (30) should be true -> " + result);
        if (result == true)
        {
           System.out.println ("[PASSED]");
        }
        else
        {
           System.out.println ("[FAILED]");
        }
       
        result = parameter.in ((new NumericIceValue(50)));
        System.out.print ("parameter.in (50) should be false -> " + result);
        if (result == false)
        {
           System.out.println ("[PASSED]");
        }
        else
        {
           System.out.println ("[FAILED]");
        }
       
        result = parameter.in ((new NumericIceValue(9.999999)));
        System.out.print ("parameter.in (10) should be false -> " + result);
        if (result == false)
        {
           System.out.println ("[PASSED]");
        }
        else
        { 
           System.out.println ("[FAILED]");
        }
       
        dResult = parameter.count ();
        System.out.print ("parameter.count should be 201 -> " + dResult);
        if (dResult == 201)
        {
           System.out.println ("[PASSED]");
        }
        else
        {
           System.out.println ("[FAILED]");
        }
        
        vResult = (NumericIceValue) parameter.minimum ();
        System.out.print ("parameter.minimum () should be 10.0 -> " + vResult);
        if (vResult.getIceValue () == 10)
        {
           System.out.println ("[PASSED]");
        }
        else
        {
           System.out.println ("[FAILED]");
        }
	   
	   
	    vResult = (NumericIceValue) parameter.maximum ();
        System.out.print ("parameter.maximum () should be 30 -> " + vResult);
        if (vResult.getIceValue () == 30)
        {
           System.out.println ("[PASSED]");
        }
        else
        {
           System.out.println ("[FAILED]");
        }
	  
        vResult = (NumericIceValue) parameter.next (new NumericIceValue (29.9));
        System.out.print ("parameter.next () should be 30.0 -> " + vResult);
        if (vResult.getIceValue () == 30)
        {
           System.out.println ("[PASSED]");
        }
        else
        {
           System.out.println ("[FAILED]");
        }
        
        vResult = (NumericIceValue) parameter.next (new NumericIceValue (30));
        System.out.print ("parameter.next (30.0) should be NaN -> " + vResult);
        if (Double.isNaN (vResult.getIceValue ()))
        {
           System.out.println ("[PASSED]");
        }
        else
        {
           System.out.println ("[FAILED]");
        }   
           
        vResult = (NumericIceValue) parameter.previous (new NumericIceValue (10.1));
        System.out.print ("parameter.previous (10.1) should be 10.0 -> " + vResult);
        if (vResult.getIceValue () == 10)
        {
           System.out.println ("[PASSED]");
        }
        else
        {
           System.out.println ("[FAILED]");
        }
       
        vResult = (NumericIceValue) parameter.previous (new NumericIceValue (10));
        System.out.print ("parameter.previous (10) should be NaN -> " + vResult);
        if (Double.isNaN (vResult.getIceValue ()))
        {
           System.out.println ("[PASSED]");
        }
        else
        {
           System.out.println ("[FAILED]");
        }
       
        return testResult;
    }  
    
    public static void numericParameterTest1 ()
    {
       String s;
       NumericParameter sender1;
       NumericParameter sender2;
       
       boolean          result;
       
       System.out.println ("Testing Set functions");
       
       try
       {
           sender1 = new NumericParameter ("duration",
                                           "P0",
                                           IceNegotiable.NEGOTIATE,
                                           10.0,30.0,15,.1);
  
           // test NumericParameter initialised with a span
           setiableTest (sender1);                              
                                         
           /* test NumericParameter initialised with an enum                                                                        
           s = buildParameterString ("10","30",".1");   
           sender2 = new NumericParameter ("duration",
                                           "P0",
                                           IceNegotiable.NEGOTIATE,
                                           15.0, s, 1);
           
           System.out.println (sender2);
           setiableTest (sender2);
           */
       }
       catch (IceInternalError e)
       {
        
       }
       catch (IceOutOfRange e)
       {
        
       }
       catch (CloneNotSupportedException e)
       {
        
       }      
    }  
   
   
    public static void numericParameterTest2 ()
    {
       String           s;
       boolean          result = false;
       NumericParameter receiver1;
       NumericParameter dummy;
       NumericParameter sender1;
       NumericParameter sender2;
       
       System.out.println ("Testing Negotiable methods");
       
       try
       {
           receiver1 = new NumericParameter ("duration",
                                             "P0",
                                             IceNegotiable.NEGOTIATE,
                                             10.0,30.0,15,.1);
           
           dummy = new NumericParameter ("duration",
                                         "P4",
                                         IceNegotiable.NEGOTIATE,
                                         10.0,30.0,15,.1);                              
                                                                                
           sender1 = new NumericParameter   ("duration",
                                             "P1",
                                             IceNegotiable.NEGOTIATE,
                                             15.0,25.0,17,.1);
                                           
           sender2 = new NumericParameter  ("duration",
                                            "P2",
                                            IceNegotiable.REQUIRE,
                                            1, 15, 5, .1);
                                           
                                           
           System.out.println ("Receiver : " + receiver1);
           System.out.println ("Sender   : " + sender1);
           System.out.println ("Sender   : " + sender2);
           
           // test isNegotiable
           result = sender1.isNegotiable ();
           System.out.print ("Sender1 is negotiable should be true: " + result);
           result = sender1.isNegotiable ();
           if (result == true)
           {
              System.out.println (" [PASSED]");
           }
           else
           {
              System.out.println (" [FAILED]");
           }
           
           result = sender2.isNegotiable ();
           System.out.print ("Sender2 is negotiable should be false: " + result);
           if (result == false)
           {
              System.out.println (" [PASSED]");
           }
           else
           {
              System.out.println (" [FAILED]");
           }
            
           // test reject 
           System.out.println ("Dummy: " + dummy);
           result = dummy.isRejected ();
           System.out.print ("dummy isRejected should be false: " + result);
           if (result == false)
           {
              System.out.println (" [PASSED]");
           }
           else
           {
              System.out.println (" [FAILED]");
           }
           
           result = dummy.isError ();
           System.out.println ("dummy is in error should be false: " + result);
           if (result == false)
           {
              System.out.println (" [PASSED]");
           }
           else
           {
              System.out.println (" [FAILED]");
           }
             
           dummy.reject (451);
           System.out.println ("Dummy: " + dummy);
           result = dummy.isRejected ();
           System.out.print ("dummy isRejected should be true: " + result);
           if (result == true)
           {
              System.out.println (" [PASSED]");
           }
           else
           {
              System.out.println (" [FAILED]");
           }
           
           result = dummy.isError ();
           System.out.println ("dummy is in error should be true: " + result);
           if (result == true)
           {
              System.out.println (" [PASSED]");
           }
           else
           {
              System.out.println (" [FAILED]");
           } 
                    
           // test isAcceptable
           result = receiver1.isAcceptable (sender1);
           System.out.print ("Sender1 is acceptable to Receiver1 should be true: " + result);
           
           if (result == true)
           {
              System.out.println (" [PASSED]");
           }
           else
           {
              System.out.println (" [FAILED]");
           }
           
           result = receiver1.isAcceptable (sender2);
           System.out.print ("Sender2 is acceptable to Receiver1 should be false: " + result);
           
           if (result == false)
           {
              System.out.println (" [PASSED]");
           }
           else
           {
              System.out.println (" [FAILED]");
           }
           
           // test isAccepted
           result = receiver1.isAccepted ();
           System.out.print ("Receiver1 isAccepted should be false: " + result);
           if (result == false)
           {
              System.out.println (" [PASSED]");
           }
           else
           {
              System.out.println (" [FAILED]");
           }
           
           // test accept
           receiver1.accept (sender1);
           System.out.println (receiver1);
           
           // test isAccepted
           result = receiver1.isAccepted ();
           System.out.print ("Receiver1 isAccepted should be true: " + result);
           if (result == true)
           {
              System.out.println (" [PASSED]");
           }
           else
           {
              System.out.println (" [FAILED]");
           }        
       }
       catch (IceInternalError e)
       {
        
       }
       catch (IceOutOfRange e)
       {
        
       }
       catch (CloneNotSupportedException e)
       {
        
       }      
    }  
   
   
    public static void numericParameterTest3 ()
    {
       String           s;
       boolean          result = false;
       NumericParameter receiver1;
       NumericParameter dummy;
       NumericParameter sender1;
       NumericParameter sender2;
       IceNegotiable reply, reply1;
       
       System.out.println ("Testing Negotiable methods");
       
       try
       {
           receiver1 = new NumericParameter ("duration",
                                             "P0",
                                             IceNegotiable.NEGOTIATE,
                                             10.0,30.0,15,.1);
           
           dummy = new NumericParameter ("duration",
                                         "P4",
                                         IceNegotiable.NEGOTIATE,
                                         10.0,30.0,15,.1);                              
                                                                                
           sender1 = new NumericParameter   ("duration",
                                             "P1",
                                             IceNegotiable.NEGOTIATE,
                                             15.0,25.0,17,.1);
                                           
           sender2 = new NumericParameter  ("duration",
                                            "P2",
                                            IceNegotiable.REQUIRE,
                                            1, 15, 5, .1);
                                           
                                           
           System.out.println ("Receiver : " + receiver1);
           System.out.println ("Sender   : " + sender1);
           System.out.println ("Sender   : " + sender2);
           
           reply = receiver1.negotiate (sender1);
           System.out.println ("Receiver : " + receiver1);
           
           reply1 = receiver1.propose (sender1);
           System.out.println ("Receiver : " + receiver1);
       }
       catch (IceInternalError e)
       {
        
       }
       catch (IceOutOfRange e)
       {
        
       }
       catch (CloneNotSupportedException e)
       {
        
       }  
       catch (Sorry e)
       {
        
       }
    }  
    
    public static void offerTest1 ()
    {
       
       //session and application do nothing for now 
       IceNegotiable reply;
       SampleOffer  sender;
       SampleOffer  receiver;
       SampleIceApplication application = null;
       IceSession session = null;
       
       TestOfferPolicy policy = null;
       NumericParameter senderParameter[] ;
       NumericParameter receiverParameter[];
       
       senderParameter = new NumericParameter[6];
       receiverParameter = new NumericParameter[6];
       
       LinkedList senderlist = null;
       LinkedList receiverlist = null;
       
       try
       {
       senderParameter[0] = new NumericParameter ("A",
                                                  "P0",
                                                  IceNegotiable.ACCEPT,
                                                  1,30.0,15,.1);
                                                  
       senderParameter[1] = new NumericParameter ("B",
                                                  "P1",
                                                  IceNegotiable.ACCEPT,
                                                  1,30.0,15,.1);
                                                  
       senderParameter[2] = new NumericParameter ("C",
                                                  "P2",
                                                  IceNegotiable.ACCEPT,
                                                  1,30.0,15,.1);
                                                  
       receiverParameter[0] = new NumericParameter ("A",
                                                    "P10",
                                                    IceNegotiable.NEGOTIATE,
                                                    1,30.0,15,.1);
                                                  
       receiverParameter[1] = new NumericParameter ("B",
                                                    "P11",
                                                    IceNegotiable.NEGOTIATE,
                                                    1,30.0,15,.1);
                                                  
       receiverParameter[2] = new NumericParameter ("C",
                                                    "P12",
                                                    IceNegotiable.NEGOTIATE,
                                                    1,30.0,15,.1);
       
       application = new SampleIceApplication ();
       session = new IceSession ("S1");
       policy = new TestOfferPolicy ();
       
       senderlist = new LinkedList ();
       receiverlist = new LinkedList ();
       
       for (int n = 0 ; n <= 2 ; n++)
       {
           senderlist.add (senderParameter [n]);
           receiverlist.add (receiverParameter [n]);
       }
       
       sender = new SampleOffer ("sender", 
	                             "O1",  
	                              senderlist, 
	                              policy, 
	                              session,
	                              application);
       
       receiver = new SampleOffer ("receiver", 
	                               "02", 
	                               receiverlist,
	                               policy, 
	                               session,
	                               application);
       
       System.out.println (sender);
       System.out.println (receiver);
       
       //now cross your fingers
       reply = receiver.negotiate (sender);
       System.out.println (reply);
       }
       catch (Sorry e)
       {
          System.out.println ("eSorry thrown");
       }
       catch (InternalError e)
       {
          System.out.println ("Internal Error thrown");
       }
       catch (OutOfRange e)
       {
          System.out.println ("IceOutOfRange thrown");
       }
       catch (CloneNotSupportedException e)
       {
          System.out.println ("CloneNotSupportException Error thrown");
       }   
    }
   
   public static void offerTest2 ()
   {
       // test the equals ()
       
       NumericParameter a,b,c,d,e,f,g ;
       boolean result;
   
       try
       {
           a = new NumericParameter ("A","P0",IceNegotiable.ACCEPT,
                                    1,30.0,15,.1);
                                      
           b = new NumericParameter ("A","P1",IceNegotiable.ACCEPT,
                                     1,30.0,15,.1);      
       
           c = new NumericParameter ("C","P2",IceNegotiable.ACCEPT,
                                    1,30.0,15,.1);                            
       
           // different status
           d = new NumericParameter ("D","P3",IceNegotiable.NEGOTIATE,
                                      1,30.0,15,.1);                                
           // different min
           e = new NumericParameter ("A","P4",IceNegotiable.NEGOTIATE,
                                     10,30.0,15,.1); 
           // different max                          
           f = new NumericParameter ("A","P5",IceNegotiable.NEGOTIATE,
                                     1,45.0,15,.1);
           // different count                          
           g = new NumericParameter ("A","P5",IceNegotiable.NEGOTIATE,
                                    10,30.0,15,.01);
                                    
           result = a.equals (b);
           System.out.println ("A equals B should be true " + result + " ");
           if (result == true)
           {
              System.out.println ("[PASSED]");
           }
           else
           {
              System.out.println ("[FAILED]");
           }  
           
           result = a.equals (c);
           System.out.println ("A equals C should be false " + result + " ");
           if (result == false)
           {
              System.out.println ("[PASSED]");
           }
           else
           {
              System.out.println ("[FAILED]");
           }  
           
           result = a.equals (d);
           System.out.println ("A equals D should be false " + result + " ");
           if (result == false)
           {
              System.out.println ("[PASSED]");
           }
           else
           {
              System.out.println ("[FAILED]");
           }  
           
           result = a.equals (e);
           System.out.println ("A equals E should be false " + result + " ");
           if (result == false)
           {
              System.out.println ("[PASSED]");
           }
           else
           {
              System.out.println ("[FAILED]");
           }  
           
           result = a.equals (f);
           System.out.println ("A equals f should be false " + result + " ");
           if (result == false)
           {
              System.out.println ("[PASSED]");
           }
           else
           {
              System.out.println ("[FAILED]");
           }  
           
           result = a.equals (g);
           System.out.println ("A equals G should be false " + result + " ");
           if (result == false)
           {
              System.out.println ("[PASSED]");
           }
           else
           {
              System.out.println ("[FAILED]");
           }  
           
           
       }                             
       catch (IceInternalError exception)
       {
        
       }
       catch (CloneNotSupportedException exception)
       {
        
       }
       catch (IceOutOfRange exception)
       {
        
       }
    }
    
       
   public static void offerTest3 ()
   {
      // recover back up.    
   }   
   
   
   
    public static void offerTest4 ()
    {
       //session and application do nothing for now 
       IceNegotiable reply;
       SampleOffer  subOffer;
       SampleOffer  synOffer;
       SampleOffer  subscriber;
       SampleOffer  syndicator;
       SampleIceApplication application = null;
       IceSession session = null;
       
       TestLimitsOfferPolicy policy = null;
       IntransigentPolicy parameterPolicy = null;
       NumericParameter subscriberParameter[] ;
       NumericParameter syndicatorParameter[];
       
       subscriberParameter = new NumericParameter[6];
       syndicatorParameter = new NumericParameter[6];
       
       LinkedList subscriberlist = null;
       LinkedList syndicatorlist = null;
       
       application = new SampleIceApplication ();
       session = new IceSession ("S1");
       policy = new TestLimitsOfferPolicy ();
       parameterPolicy = new IntransigentPolicy ();
       
       try
       {
       subscriberParameter[0] = new NumericParameter ("A",
                                                      "P1",
                                                      IceNegotiable.NEGOTIATE,
                                                      1,30.0,15,.1,
                                                      parameterPolicy);
                                                  
       subscriberParameter[1] = new NumericParameter ("B",
                                                      "P1",
                                                      IceNegotiable.NEGOTIATE,
                                                      1,30.0,15,.1,
                                                      parameterPolicy);
       
       subscriberParameter[2] = new NumericParameter ("C",
                                                      "P2",
                                                      IceNegotiable.NEGOTIATE,
                                                      1,30.0,15,.1,
                                                      parameterPolicy);                                           
                                                                                                    
       syndicatorParameter[0] = new NumericParameter ("A",
                                                      "P3",
                                                      IceNegotiable.NEGOTIATE,
                                                      1,30.0,15,.1,
                                                      parameterPolicy);
                                                 
       syndicatorParameter[1] = new NumericParameter ("B",
                                                      "P4",
                                                      IceNegotiable.NEGOTIATE,
                                                      1,30.0,15,.1,
                                                      parameterPolicy);
                                                      
       syndicatorParameter[2] = new NumericParameter ("C",
                                                      "P5",
                                                      IceNegotiable.NEGOTIATE,
                                                      1,30.0,15,.1,
                                                      parameterPolicy);                                               
                                                    
       application = new SampleIceApplication ();
       session = new IceSession ("S1");
       policy = new TestLimitsOfferPolicy ();
       parameterPolicy = new IntransigentPolicy ();
       
       subscriberlist = new LinkedList ();
       syndicatorlist = new LinkedList ();
       
       subscriberlist.add (subscriberParameter [0]);
       subscriberlist.add (subscriberParameter [1]);
       subscriberlist.add (subscriberParameter [2]);
       
       // place the syndicator's list in the 
       // opposite order
       syndicatorlist.add (syndicatorParameter [2]);
       syndicatorlist.add (syndicatorParameter [1]);
       syndicatorlist.add (syndicatorParameter [0]);
       
       
       subscriber =  new SampleOffer ("subscriber", 
	                                  "O1",  
	                                  subscriberlist, 
	                                  policy, 
	                                  session,
	                                  application);
       
       syndicator = new SampleOffer ("syndicator", 
	                                 "02", 
	                                 syndicatorlist,
	                                 policy, 
	                                 session,
	                                 application);
       
        System.out.println (subscriber);
        System.out.println (syndicator);
       
        subOffer = subscriber;
        synOffer = (SampleOffer) syndicator.negotiate (subscriber);
        
        // the order now should be 
        // subscriber A,B,C
        // syndicator A,C,B
       
        System.out.println (subOffer);
        System.out.println (synOffer);
       }  
       catch (IndexOutOfBoundsException e)
       {
          System.out.println (e);
       }
       catch (Sorry e)
       {
           System.out.println ("Sorry thrown");
       }
       catch (InternalError e)
       {
          System.out.println ("Internal Error thrown");
       }
       catch (OutOfRange e)
       {
          System.out.println ("IceOutOfRange thrown");
       }
       catch (CloneNotSupportedException e)
       {
          System.out.println ("CloneNotSupportException Error thrown");
       }      
    }    
    
    
    // Test offerTest 4_1 tests the resolution/reordering
    // mechanism
                  
                  
    public static void offerTest4_1 ()
    {
       //session and application do nothing for now 
       IceNegotiable reply;
       SampleOffer  subOffer;
       SampleOffer  synOffer;
       SampleOffer  subscriber;
       SampleOffer  syndicator;
       SampleIceApplication application = null;
       IceSession session = null;
       
       TestLimitsOfferPolicy policy = null;
       IntransigentPolicy parameterPolicy = null;
       NumericParameter senderParameter[] ;
       NumericParameter receiverParameter[];
       
       senderParameter = new NumericParameter[6];
       receiverParameter = new NumericParameter[6];
       
       LinkedList senderlist = null;
       LinkedList receiverlist = null;
       
       application = new SampleIceApplication ();
       session = new IceSession ("S1");
       policy = new TestLimitsOfferPolicy ();
       parameterPolicy = new IntransigentPolicy ();
       
       try
       {
       senderParameter[0] = new NumericParameter ("A",
                                                  "P0",
                                                  IceNegotiable.NEGOTIATE,
                                                  1,30.0,15,.1,
                                                  parameterPolicy);
                                                  
       
                                                  
       receiverParameter[0] = new NumericParameter ("A",
                                                    "P10",
                                                    IceNegotiable.NEGOTIATE,
                                                    1,30.0,15,.1,
                                                    parameterPolicy);
                                                 
       
       application = new SampleIceApplication ();
       session = new IceSession ("S1");
       policy = new TestLimitsOfferPolicy ();
       parameterPolicy = new IntransigentPolicy ();
       
       senderlist = new LinkedList ();
       receiverlist = new LinkedList ();
       
       senderlist.add (senderParameter [0]);
       receiverlist.add (receiverParameter [0]);
     
       
       subscriber =  new SampleOffer ("subscriber", 
	                                  "O1",  
	                                  senderlist, 
	                                  policy, 
	                                  session,
	                                  application);
       
       syndicator = new SampleOffer ("syndicator", 
	                                 "02", 
	                                 receiverlist,
	                                 policy, 
	                                 session,
	                                 application);
       
        System.out.println (subscriber);
        System.out.println (syndicator);
       
        subOffer = subscriber;
        for (int n = 0 ; n <= 3 ; n++)
        {
            System.out.println ("PASS " + n);
            System.out.println ("SUBOFFER BEFORE" + subscriber);
            synOffer = (SampleOffer) syndicator.negotiate (subOffer);
            System.out.println ("SUBOFFER AFTER->" + subscriber);
            subOffer = (SampleOffer) subscriber.negotiate (synOffer);
            System.out.println ("SUBOFFER ->" + subOffer);   
        }
       
       //synOffer = syndicator;
       //System.out.println ("INITIAL " + synOffer);
       //for (int n = 0 ; n <= 3 ; n++)
       //{
       //    System.out.println ("PASS " + n);
       //    subOffer = (SampleOffer) subscriber.negotiate (synOffer);
       //    System.out.println ("SUBOFFER ->" + subOffer);
       //    synOffer = (SampleOffer) syndicator.negotiate (subOffer);
       //    System.out.println ("SYNOFFER ->" + synOffer);   
       //}
       
       }  
       catch (IndexOutOfBoundsException e)
       {
          System.out.println (e);
       }
       catch (IceSorry e)
       {
          System.out.println ("IceSorry thrown");
       }
       catch (IceInternalError e)
       {
          System.out.println ("Internal Error thrown");
       }
       catch (IceOutOfRange e)
       {
          System.out.println ("IceOutOfRange thrown");
       }
       catch (CloneNotSupportedException e)
       {
          System.out.println ("CloneNotSupportException Error thrown");
       }      
    }               
              
    public static void sessionTest ()
    {
        IceSession session = new IceSession ("S1");
        System.out.println (session);
        IceSessionProxy sessionProxy;
        
        sessionProxy = new IceSessionProxy (session);
        System.out.println (sessionProxy);
        
        // check if lapsed time is working
        for (int n = 0 ; n <= 10 ; n++)
        {
             System.out.println (session);
             System.out.println (sessionProxy);
             session.incrementRound ();
        } 
    }
  
   public static void offerTest5 ()
   {
   
   
   
   }
  
  
  
    public static void main (String [] argv)
    {
      
       //  sessionTest ();
       // offerTest4_1 ();
       //offerTest1 ();
       // ? offerTest3 (); 
       //offerTest2 ();
       offerTest4 (); 
       //numericParameterTest1 ();
       // numericParameterTest2 ();
       //numericParameterTest3 ();
    }   
} // icecubes  
