package com.adobe.rice.common.negotiation.tests;
import com.adobe.rice.common.negotiation.*;
import com.adobe.rice.common.negotiation.InternalError;
import java.util.*;
import java.lang.*;
import java.math.*;


public class OfferTester
{
  
  public static void offerTest4 ()
  {
       //session and application do nothing for now 
       IceNegotiable reply;
       SampleOffer  subOffer = null;
       SampleOffer  synOffer = null;
       SampleOffer  subscriber;
       SampleOffer  syndicator;
       SampleIceApplication application = null;
       
       // define the parameters
       NumericParameter subscriberParameter[] = new NumericParameter[6];
       NumericParameter syndicatorParameter[] = new NumericParameter[6];
       
       LinkedList subscriberlist = null;
       LinkedList syndicatorlist = null;
       
       application = new SampleIceApplication ();
        
       // if the default is not equal then echo
       // the sender's default and range. 
       EchoPolicy policy = new EchoPolicy ();
       IceSession session = null;
       
       try
       {
           subscriberParameter[0] = new NumericParameter ("A",
                                                 "P1",
                                                 IceNegotiable.NEGOTIATE,
                                                 1,
                                                 30.0,
                                                 16,
                                                 .1,
                                                 true,
                                                 policy,
                                                 application);
                                                 
           subscriberParameter[1] = new NumericParameter ("B",
                                                 "P2",
                                                 IceNegotiable.NEGOTIATE,
                                                 11,
                                                 39.0,
                                                 21,
                                                 .1,
                                                 true,
                                                 policy,
                                                 application);
       
           subscriberParameter[2] =  new NumericParameter ("C",
                                                  "P3",
                                                  IceNegotiable.NEGOTIATE,
                                                  110,
                                                  190,
                                                  150,
                                                  .1,
                                                  true,
                                                  policy,
                                                  application);                                           
                                                    
           subscriberParameter[3] = new NumericParameter ("D",
                                                 "P4",
                                                 IceNegotiable.ACCEPT,
                                                 1,
                                                 30.0,
                                                 16,
                                                 .1,
                                                 true,
                                                 policy,
                                                 application); 
                                                    
           subscriberParameter[4] = new NumericParameter ("E",
                                                 "P5",
                                                 IceNegotiable.NEGOTIATE,
                                                 1,
                                                 30.0,
                                                 16,
                                                 .1,
                                                 true,
                                                 policy,
                                                 application); 
                                                    
                                                    
           syndicatorParameter[0] =  new NumericParameter ("A",
                                                  "P3",
                                                  IceNegotiable.NEGOTIATE,
                                                  1,
                                                  30.0,
                                                  17,
                                                  .1,
                                                  true,
                                                  policy,
                                                  application);
                                                  
                                                 
           syndicatorParameter[1] = new NumericParameter  ("B",
                                                  "P4",
                                                  IceNegotiable.NEGOTIATE,
                                                  11,
                                                  39.0,
                                                  23,
                                                  .1,
                                                  true,
                                                  policy,
                                                  application);
                                                  
           syndicatorParameter[2] = new NumericParameter  ("C",
                                                  "P5",
                                                  IceNegotiable.NEGOTIATE,
                                                  110,
                                                  190,
                                                  155,  
                                                  .1,
                                                  true,
                                                  policy,
                                                  application);                                           
                                                       
           syndicatorParameter[3] = new NumericParameter ("D",
                                                 "P1",
                                                 IceNegotiable.NEGOTIATE,
                                                 1,
                                                 30.0,
                                                 16,
                                                 .1,
                                                 true,
                                                 policy,
                                                 application); 
                                                    
           syndicatorParameter[4] = new NumericParameter ("E",
                                                 "P1",
                                                 IceNegotiable.NEGOTIATE,
                                                 1,
                                                 30.0,
                                                 16,
                                                 .1,
                                                 true,
                                                 policy,
                                                 application); 
                                    
                                                 
           application = new SampleIceApplication ();
           SimplePolicy simplePolicy = new SimplePolicy ();
       
           subscriberlist = new LinkedList ();
           syndicatorlist = new LinkedList ();
       
           subscriberlist.add (subscriberParameter [0]);
           subscriberlist.add (subscriberParameter [1]);
           subscriberlist.add (subscriberParameter [2]);
           subscriberlist.add (subscriberParameter [3]);
           subscriberlist.add (subscriberParameter [4]);
       
           // place the syndicator's list in the 
           // opposite order
           syndicatorlist.add (syndicatorParameter [4]);
           syndicatorlist.add (syndicatorParameter [3]);
           syndicatorlist.add (syndicatorParameter [2]);
           syndicatorlist.add (syndicatorParameter [1]);
           syndicatorlist.add (syndicatorParameter [0]);
       
       
           subscriber =  new SampleOffer ("subscriber", 
	                                      "O1",  
	                                      subscriberlist, 
	                                      simplePolicy, 
	                                      application);
       
           syndicator = new SampleOffer  ("syndicator", 
	                                      "02", 
	                                      syndicatorlist,
	                                      simplePolicy, 
	                                      application);
       
          
           //
           // The for loop simulates the exchange between
           // two ICE processors
           //
           System.out.println ("INITIAL: " + subscriber);
           System.out.println ("INITIAL: " + syndicator);
           subOffer = subscriber;
          
           for (int round = 0 ;; round++)
           { 
               //System.out.println ("ROUND " + round + " SUB: " + subOffer); 
               System.out.print ("ROUND " + round + " SUB: " + subOffer + "focus: ");
               System.out.println (subOffer.hasFocus () ? subOffer.getFocus ().getName ().toString () : "no focus");
               
               
               synOffer = (SampleOffer) syndicator.negotiate (subOffer);     
                   
               if (synOffer.isAccepted () || synOffer.isRejected ())
               {
                  break;
               }
               
               //System.out.println ("ROUND " + round + " SYN: " + synOffer);
               System.out.print ("ROUND " + round + " SYN: " + synOffer + "focus: ");
               System.out.println (synOffer.hasFocus () ? synOffer.getFocus ().getName ().toString () : "no focus");
               subOffer = (SampleOffer) subscriber.negotiate (synOffer);
           }
       
           System.out.println (subOffer);
           System.out.println (synOffer);
       }  
       catch (IndexOutOfBoundsException e)
       {
           System.out.println (e);
       }
       catch (Sorry e)
       {
           System.out.println ("IceSorry thrown");
       }
       catch (InternalError e)
       {
           System.out.println ("Internal Error thrown");
       }
       catch (OutOfRange e)
       {
           System.out.println ("IceOutOfRange thrown");
       }    
    } 
   
    public static void main (String [] argv)
    {
       offerTest4 (); 
       //utilityPolicyTest ();
    } 
    
} // icecubes  
