package com.adobe.rice.common.negotiation.tests;
import com.adobe.rice.common.negotiation.*;
import com.adobe.rice.common.negotiation.InternalError;

public class SimplePolicy extends OfferStrategy
{
    // isAcceptable in Offers is problematic -
    // isAcceptable is expensive but doesn't really buy much
    // negotiate () doesn't use it.
    
    public boolean isAcceptable(Negotiable sender, 
                                Negotiable receiver)
    {
        return true;
    }

    // Negotiate is going to disappear from IceOfferPolicy
    // it is not called
    public Negotiable negotiate (Negotiable sender, Negotiable receiver) throws InternalError
    {
        return null;
    }

    // propose does not really do anything either.
    // it can probably go
    public Negotiable propose(Negotiable sender, 
                                 Negotiable receiver)
    {
        return null;
    }


    public Negotiable ratify (Negotiable sender, Negotiable receiver) throws InternalError
    {
        // if all receiver's negotiables are resolved, then
        // issue the okay
        if (((Offer)receiver).isResolved ())
        {
            receiver.accept (sender);
        }
        return receiver;
    }

    public void reorder(Negotiable receiver)
    {
        // do nothing
    }

    public Offer resolveImpasse(Negotiable sender, Negotiable receiver) throws InternalError
    {
        // default - reject
        receiver.reject (Negotiable.SORRY);
        return (Offer) receiver;
    }

}