/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/payloadAssembly/AssemblyConstants.java,v 1.1 2000/12/02 23:24:24 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/

package com.adobe.rice.common.payloadAssembly;
/** Adobe RICE */

import java.io.*;

import com.adobe.rice.common.XMLassembly.*;
import com.adobe.rice.common.policies.*;

public final class AssemblyConstants 
{
    // The following defines the EXACT representations of the various ICE versions
    // as defined by the public releases of the specifications.
    public final static String versions[] = { "1.0", "1.01", "1.1", "1.2" };
    
    public final static String ICE_VERSION="1.1";
    public final static String ICE_USER_AGENT = "ICEcubes 0.50 ICE processor. \n" +
                                                "(c)1998-2001 ICE Authoring Group.\n" +
                                                "http://www.icestandard.org \n" +
                                                "hosted by IdeAlliance";
    public final static String ICE_LANGUAGE = "en";
    //
    // The following constants are normally overrridden by policies in the configuration file.
    // These are the hardwired values that result if no policy overrides.
    //
    public final static String fixedIceDTDvariant = "standard";
    public final static String fixedIceDTDpath = "http://localhost/ice";
    public final static String fixedIceDTDname = "ice1_1.dtd";
    public final static String fixedIceDTDversion = ICE_VERSION;
    public final static String fixedIceLanguage = ICE_LANGUAGE;
    
    public final static String fixedNotifyPriority = "2";
    
    //
    // silly formatting routine that should be removed at some point
    //
    
    public static String getWhiteSpace( int nest )
    {
        // $FIX$ this cheesey function to be more efficient.
        String s = "";
        for ( int i = 0; i < nest ; i++ ) s += " ";
        return s;
    }
}