/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/payloadAssembly/Header.java,v 1.3 2000/12/02 23:24:24 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/

package com.adobe.rice.common.payloadAssembly;

import java.util.*;

//
// icecubes  imports
//
import com.adobe.rice.IceCubes;
import com.adobe.rice.common.*;
import com.adobe.rice.common.XMLassembly.*;
import com.adobe.rice.common.policies.*;
import com.adobe.rice.common.storage.logging.*;     // so we can write to the log.
import com.adobe.rice.common.payloadAssembly.header.*;

public class Header extends AssemblyElement 
{
    // ice-header, ice-sender, ice-receiver and ice-user-agent formats
    // <!ELEMENT ice-header ( ice-sender, ice-receiver?, ice-user-agent? ) >
    //
    // <!ELEMENT ice-sender EMPTY >
    // <!ATTLIST ice-sender sender-id CDATA      #REQUIRED 
    //                      name      CDATA      #REQUIRED
    //                      role      (subscriber | syndicator) #REQUIRED >
    //
    // <!ELEMENT ice-receiver EMPTY > 
    // <!ATTLIST ice-receiver receiver-id CDATA    #REQUIRED
    //                        name        CDATA    #REQUIRED >
    //
    // <!ELEMENT ice-user-agent    (#PCDATA) >

    
    public Header( Element parent, DocType dtd ) throws ElementException
    {
        super("ice-header", parent, dtd );
        this.setOkToFormat(true);       // ok to format.
        
        this.open();
        try
        {
            this.add( (Element) new Sender( this, dtd ) );
            // $FIX$ do not insert a receiver for now;  When and why?..
            this.add( (Element) ( new UserAgent( this, dtd ) ) );
        }
        catch ( ElementException ee )
        {
            throw ee;
        }
        finally
        {
            this.close();
        }
        
    }
    
}
