/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/payloadAssembly/PayloadDoc.java,v 1.4 2000/12/02 23:24:23 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/

package com.adobe.rice.common.payloadAssembly;

//
// java imports
//
import java.io.*;
import java.util.*;

//
// icecubes  imports
//
import com.adobe.rice.IceCubes;
import com.adobe.rice.common.*;
import com.adobe.rice.common.XMLassembly.*;
import com.adobe.rice.common.policies.*;
import com.adobe.rice.common.storage.logging.*;     // so we can write to the log.

public class PayloadDoc extends XMLdoc 
{
    // <!ELEMENT ice-payload ( ice-header, ( ice-request+ |  
    //                                       ice-response+ | 
    //                                       ice-unsolicited-now | 
    //                                       ice-unsolicited-request+ |  
    //                                       ice-unsolicited-response+ 
    //                                     ) 
    //                       ) 
    // >  
    // <!ATTLIST ice-payload  
    //                       payload-id      CDATA #REQUIRED 
    //                       timestamp       CDATA #REQUIRED 
    //                       sender-location CDATA #REQUIRED 
    //                       ice.version     CDATA #REQUIRED 
    // >
    
    public PayloadDoc( DocType iceDTD ) throws ElementException, XMLdocException 
    {
        super( iceDTD );    // construct the default empty XMLdoc.
        this.setOkToFormat(true);
        //
        // Insert the root element, ice-payload
        //
        Payload root;
        
        this.open("Root");
        // The ICE DTD's root is always "ice-payload"
        try 
        { 
            root = new Payload(iceDTD );
            this.add(root); 
        }
        catch ( XMLdocException dBad ) 
        { 
            Object parms[] = {"ice-payload", "document", dBad.getMessage() };
            AssemblyMessages.log(
                AssemblyMessages.get("invalid"), 
                parms, ImpactRange.FATAL );
            throw dBad; 
        }
        catch ( ElementException eBad ) 
        {   
            Object parms[] = {"ice-payload", "root element", eBad.getMessage() };
            AssemblyMessages.log(
                AssemblyMessages.get("invalid"), 
                parms, ImpactRange.FATAL );
            throw eBad; 
        }  
    }
}
