/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/payloadAssembly/Response.java,v 1.2 2000/12/02 23:24:23 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/

package com.adobe.rice.common.payloadAssembly;

import java.util.*;

//
// icecubes  imports
//
import com.adobe.rice.util.*;

import com.adobe.rice.IceCubes;
import com.adobe.rice.common.*;
import com.adobe.rice.common.XMLassembly.*;
import com.adobe.rice.common.policies.*;
import com.adobe.rice.common.storage.logging.*;     // so we can write to the log.
import com.adobe.rice.common.payloadAssembly.*;     // 

public class Response extends AssemblyElement 
{
    private ResponseIdentifier responseId;
    
    private boolean unsolicitedPending = false;
    
    /*
        <!ELEMENT ice-response (ice-code,
                                   ( ice-cancellation |
                                     ice-catalog      |
                                     ice-event-log    |
                                     ice-offer        |
                                     ice-location     |
                                     ice-package+     |
                                     ice-sequence     |
                                     ice-status       |
                                     ice-subscription |
                                   )?
                                ) >
        <!ATTLIST ice-response
                  response-id CDATA #REQUIRED
                  unsolicited-pending (false | true) "false" >
    */
    public Response( Element parent, DocType dtd ) throws ElementException
    {
        super("ice-response", parent, dtd );
        this.setOkToFormat(true);       // ok to format.
        
        // 
        // setup the attributes:
        //
        unsolicitedPending = false;
        responseId = new ResponseIdentifier();
        try 
        {
            String responseIdString = this.responseId.toString();
            String upend = (this.unsolicitedPending)?"true":"false";
            this.setAttribute("response-id", responseIdString );
            this.setAttribute("unsolicited-pending", upend );
        }
        catch( AttributeException ae )
        {
           // log the fact that we got an attribute execption...
           Object[] parms = { "ice-response", ae.getMessage() };    
           AssemblyMessages.log(AssemblyMessages.get("missingRequiredAttribute"), 
               parms, ImpactRange.CRITICAL );
        }
        
    }
    
    public ResponseIdentifier getResponseId() { return this.responseId; }
    public boolean getUnsolicitedPending() { return this.unsolicitedPending; }
    
    public void setUnsolicitedPending( boolean up ) { this.unsolicitedPending = up; }
}
