/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/payloadDisassembly/KernelHandler.java,v 1.1 2000/11/01 02:45:18 andrewf Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/

package com.adobe.rice.common.experimental;
import  com.adobe.rice.common.XMLdisassembly.*;
import  com.adobe.rice.kernel.*;

//
//  KernelHandler is a subclass of Handler that understands how to
//  dispatch messages to other systems in the ICE Processor
//

public class KernelHandler extends Handler
{ 
    public KernelHandler (XMLDisassembler disassembler, Handler parent) 
	{
		super (disassembler, parent);
    }
      
    protected long send (String name, IceMessage message)
    {
        return MessageDispatcher.instance ().asyncSend (name, message);    
    }
    
    protected IceMessage receive () throws DispatcherException
    {
        return MessageDispatcher.instance ().receive ();
    }
    
    protected IceMessage receive (long timeout) 
                         throws DispatcherException
    {
        return MessageDispatcher.instance ().receive (timeout);
    }
    
    protected IceMessage receive (String queueName)
                         throws DispatcherException
    {
        return MessageDispatcher.instance ().receive (queueName);
    }
    
    protected IceMessage receive (String queueName,
                                  long   timeout)
                         throws DispatcherException
    {
        return MessageDispatcher.instance ().receive (queueName, timeout);
    } 
    
    
    protected IceMessage synchronousSend (String     queueName, 
                                          IceMessage message)
                         throws DispatcherException
    {
        return MessageDispatcher.instance ().synchronousSend (queueName, message);  
        
    }
    
    protected IceMessage synchronousSend (String     queueName, 
                                          IceMessage message,
                                          long       msecs)
                         throws DispatcherException
    {
        return MessageDispatcher.instance ().synchronousSend (queueName, message, msecs);          
    }
    
    protected long reply (IceMessage message)
    {
        return MessageDispatcher.instance ().reply (message);   
    }
}