/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/payloadDisassembly/SenderData.java,v 1.1 2000/12/02 23:28:45 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/

package com.adobe.rice.common.payloadDisassembly;

//
// java imports:
//
import java.util.Date;
import java.net.*;
//
// icecubes imports:
//
import com.adobe.rice.util.*;

public class SenderData
{
    private UUID       senderId;
    private String     name;
    private String     role;
    private URL        location;
    
    SenderData()
    {
       // empty Sender
    }
          
    SenderData(UUID senderId, String name, String role, URL location)
    {
        this.senderId = senderId;
        this.name = name;
        this.role = role;
        this.location = location;
    }
    
    public UUID getSenderId()
    {
        return senderId;
    }
    
    public void setSenderId(UUID newSenderId)
    {
        senderId = newSenderId;
    }
    
    public String getRole()
    {
        return role;
    }
    
    public void setRole(String newRole)
    {
        role = newRole;
    }
    
    public URL getLocation()
    {
        return location;
    }
    
    public void setLocation(URL url)
    {
        this.location = url;
    }
    
    public String getName() { return name; }
    
    public void setName( String name ) { this.name = name; }
}