/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/payloadDisassembly/response/ModelHandler.java,v 1.5 2000/12/02 23:29:31 bhunt Exp $

<<ICECOPYRIGHT>>
*/

package com.adobe.rice.common.payloadDisassembly.response;

import org.xml.sax.*;
import com.adobe.rice.common.XMLdisassembly.*;
import com.adobe.rice.common.payloadDisassembly.*;

public class ModelHandler extends com.adobe.rice.common.XMLdisassembly.Handler
{
    //
    // class wide variables
    //
    static TagEntry contentTags[];

    static Content content;

    //
    // private class instance variables
    //

	private Handler	parent;

	public ModelHandler(XMLDisassembler disassembler, Handler parent) {
		super(disassembler, parent);

		this.parent = parent;

		this.element = "ModelElement";

		ParserAttributes al = new ParserAttributes();

		al.add( new AttributeEntry("ModelAttribute", "CDATA" ) );

		this.elementAttributes = al;

		if ( contentTags == null )
		{
		    contentTags = new TagEntry[]
		    {
		        // create a TagEntry for each element in ModelContent's content model here.
		        // Note that the order of the TagEntrys corresponds to the indexes used
		        // below -- if TAGNAME is the tag name in the first TagEntry, then it is
		        // index 0 below in result.
		        //
		        // replace the UnimplementedHandler in each TagEntry with an appropriate handler when you implement it.
                new TagEntry("ModelContentElement1", new UnimplementedHandler( disassembler, this)),
                new TagEntry("ModelContentElement2", new UnimplementedHandler( disassembler, this))
		    };
		}
		if ( content == null )
		{
		    content = new Content(contentTags, disassembler);
		}
	}

	public void startElement(String name, ParserAttributes attrList)
	{
	    //
	    // pull in the attributes
	    //
		if ( name.equals("ModelElement") )
		{
		    for ( int i = 0; i < attrList.getLength(); i++ )
		    {
		        String aName = attrList.getName(i);
		        String aType = attrList.getType(i);
		        String aValue = attrList.getValue(i);

		        AttributeEntry ae = this.findAttribute(aName);
		        if ( ae != null )
		        {
		            ae.setValue(aValue);
		            ae.setType(aType);
		        }
		        else /* This attribute is not defined */
		        {   /* $POLICY$ */
		            this.elementAttributes.add(new AttributeEntry(aName, aType, aValue ));
		        }
		    }
		}
		// make sure content handlers are registered.
		// do this as late as possible
		if ( name.equals("ModelElement") )
		    content.registerHandlers();
		//
		// Begin Semantic Processing Here:
		//
	}

	public void endElement(String name)
	{
	    //
	    // Complete Semantic Processing Here:
	    //
	    //
	    // call result here after completing semantic processing
	    //
	    Object[] results = 
	    { 
	        new Integer(this.getErrorCount()),
	        new Integer(this.getErrorLevel()),
	        this 
	    };
	    disassembler.result( name, results );
	    //
	    // last - unregister all my content handlers.
	    //
	    if ( name.equals("ModelElement") )
	    {
	        content.unregisterHandlers();
	    }
	}
    /**
	* Function called for element character data.
	*
	* @param    name    String containing name of element chardata is for.
	* @param	ch		array of character data.
	* @param	start	begining index of character data.
	* @param	length	length of character data.
	*
	* @see		SAXManager
     **/
	public void characters( String name, char ch[], int start, int length)
	{
	    if ( name.equals("ModelElement") )
	    {
	        // $FIX$ - If this element can contain text; it will be delivered
	        // here.  Write the semantics for the routine here.
	    }
    }
    /**
     * Function called when a sub-handler completes and returns it's work.
	 *
	 * @param   name        String containing the name of an element just completed.
	 * @param   objectArray Array of objects, with are the result of the element just
	 *                      completed.  Presumably, the called handler's result
	 *                      method knows how to handle the objects in the array,
	 *                      with the name of the completed element being the
	 *                      distinguishing hint.
	 *
	 **/
	public void result( String name, Object[] objectArray )
    {
        int i = content.index(name);
        if ( i >= 0 )
        {
            Integer elementErrorCount = (Integer) objectArray[0];
            Integer elementErrorLevel = (Integer) objectArray[1];
                
            this.bumpErrorCount(elementErrorCount.intValue() );
            this.adjustErrorLevel(elementErrorLevel.intValue() );
        }
        switch ( i )
        {
            // When an element in the content of this element completes, it calls this
            // routine with it's results.  That is if element foo has element bar as
            // content, then when element bar contained by foo completes, the result
            // is handed back to foo through this routine.
            //
            // Handle the results here.  Note -- The theory is that this handler is
            // little more than a packager of the effort of the lower level routines.
            // Build the lower level routines to handle everything that is locally possible
            // about the element.  The result routine (this one) should be designed to
            // integrate the lower level elements into a larger whole.  At this level,
            // we can do little but schedule the returning response.

            // The index here is the index of the elements in contentTags with the
            // first starting at 0.

            case 0: // ice-
                break;
            case 1: // ice-
                break;
            case 2: // ice-
                break;
            case 3: // ice-
                break;
            case 4: // ice-
                break;
            case 5: // ice-
                break;
            case 6: // ice-
                break;
            default: // unknown name
                // $LOG$ $FIX$ log and ignore.
                // $FIX$ the name is not in the content model of this element.
                // One idea is to try to load a handler with this name and see it if works...
                break;
        }
    }
}
