/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/policies/RangedFloatPolicy.java,v 1.1.1.1 2000/09/19 19:39:46 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org


*/

package com.adobe.rice.common.policies;

import com.adobe.rice.util.ExceptionMessages;

public class RangedFloatPolicy extends RangedPolicy 
{
    
    public RangedFloatPolicy(float min, float max) 
    {
        
	    super(Float.class, new Float(min), new Float(max) );
    }
	
	public RangedFloatPolicy( String name, float min, float max )
	{
	    super(Float.class, name, new Float(min), new Float(max) );
	}
	
	public RangedFloatPolicy( String name, String pkg, float min, float max )
	{
	    super(Float.class, name, pkg, new Float(min), new Float(max) );
	}
	
	//
		
	
	public void setSelection( float d ) throws PolicyException
	{
	    if ( ( d < min.floatValue() ) || ( d > max.floatValue() ) )
	        throw new PolicyException(ExceptionMessages.getExceptionMessage("ArgOutOfRange"));
	    selection = new Float( d );
	}
	
	public void setSelection( Float cd ) throws PolicyException
	{
	    float d = cd.floatValue();
	    if ( ( d < this.min.floatValue() ) || ( d > this.max.floatValue() ) )
	        throw new PolicyException(ExceptionMessages.getExceptionMessage("ArgOutOfRange"));
	    selection = cd;
	}
	
    public void setSelection(Object o) throws PolicyException 
    {
        if ( RangedPolicy.isNumber( o.getClass() ) )
        {
	        float value = ((Number)o).floatValue();		
	        if ( (value < min.floatValue()) || (value > max.floatValue()) )
	            throw new PolicyException(ExceptionMessages.getExceptionMessage("ArgOutOfRange"));
	        selection = (Number) o;
	    }
	    else
	        throw new PolicyException(ExceptionMessages.getExceptionMessage("ArgWrongType"));
    }
}


