/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/policies/configure/Constants.java,v 1.1.1.1 2000/09/19 19:39:48 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/

package com.adobe.rice.common.policies.configure;

import java.util.*;
import org.xml.sax.*;
import com.adobe.rice.common.XMLdisassembly.*;
import com.adobe.rice.common.storage.logging.*;     // so we can write to the log.

class Constants 
{    
    // start of coupled declaractions
    //
    // note that the first definition below is constrained to
    // match the integer declarations that follow.  
    // The index in the first must match the declaration
    // that follows ( so if the string "byte" is index 0, then TYPE_BYTE must
    // also be declared 0.
    
    static final String[] BUILTIN_TYPES = 
    {
        "byte", 
        "short", 
        "int", 
        "long", 
        "float", 
        "double", 
        "boolean", 
        "char", 
        "String",
        "StringBuffer"
    };
    
    static final int TYPE_BYTE = 0;
    static final int TYPE_SHORT = 1;
    static final int TYPE_INT = 2;
    static final int TYPE_LONG = 3;
    static final int TYPE_FLOAT = 4;
    static final int TYPE_DOUBLE = 5;
    static final int TYPE_BOOLEAN = 6;
    static final int TYPE_CHAR = 7;
    static final int TYPE_STRING = 8;
    static final int TYPE_STRINGBUFFER = 9;
    
    // end of coupled declarations
    
    static final char[] MAXIMUM_CHARS = 
    { 
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF', 
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF',
      '\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF','\uFFFF'    
    }; 
    
    //
    // setup the expected number of items per enumeration
    //
    static final int EXPECTED_ENUM_ITEMS = 30;
    
    //
    // setup the default item value type
    //
    static final String DEFAULT_ITEM_TYPE = "String";
    
    //
    // define the error levels for configuration errors
    //
    static final int GOOD = 0;
    static final int INFO = 2;
    static final int WARNING = 4;
    static final int ERROR = 6;
    static final int SEVERE = 8;
    static final int FATAL = 10;
    
    //
    // define the name that corresponds to all packages
    //
    static final String ALL_PACKAGES = "_ALL_";
    
    /**
    * Return the index of the type:
    *   -1 is returned if the type is not found.
    *
    * @param typeName - the String name of the type
    * @return int     - the integer index of the type
    *
    *    0 - "byte",  
    *    1 - "short", 
    *    2 - "int", 
    *    3 - "long", 
    *    4 - "float", 
    *    5 - "double",
    *    6 - "boolean", 
    *    7 - "char"
    *    8 - "String", 
    *    -1 - not a builtin type
    * @author bhunt
    **/
    public static final int getTypeIndex( String typeName )
    {
        for ( int i = 0; i < Constants.BUILTIN_TYPES.length; i++ )
        {
            if ( typeName.equals(Constants.BUILTIN_TYPES[i]) )
                return i;
        }
        return -1;
    }
    
    /**
    * Convert a String into an object of the correct type
    *
    * @param typeName - name of the type to convert to
    * @param valueString - the string containing the value rep
    * @return Object with the standard Java Object wrapper for
    *       the builtin type (typeName); or null if the
    *       type cannot be converted.
    *
    **/
    public static final Object convertValue( String typeName, String stringValue )
    {
        Object result = null;
        int i = Constants.getTypeIndex( typeName );
        try
        {
            switch ( i )
            {
            case TYPE_BYTE:
                result = new Byte(stringValue);
                break;
            case TYPE_SHORT:
                result = new Short(stringValue);
                break;
            case TYPE_INT:
                result = new Integer(stringValue);
                break;
            case TYPE_LONG:
                result = new Long(stringValue);
                break;
            case TYPE_FLOAT:
                result = new Float(stringValue);
                break;
            case TYPE_DOUBLE:
                result = new Double(stringValue);
                break;
            case TYPE_BOOLEAN:
                result = new Boolean(stringValue);
                break;
            case TYPE_CHAR:
                result = new Character(stringValue.charAt(0));
                break;
            case TYPE_STRING:
                result = new String(stringValue);
                break;
            default:
                //
                try 
                {
                    Class theClass = Class.forName(typeName);
                    result = theClass.newInstance();
                    // how to give the new object the stringValue?
                }
                catch ( Exception ex ) {}
                break;
            }
        }
        catch ( Exception ex )
        {
            Object[] parms = { typeName, stringValue, ex.toString() };    
            LogMsg logmsg = new LogMsg( Messages.conversionError , parms );
            logmsg.prolog( "common.policies.config", 200000000, "error" );
            logmsg.log();
            // if the message is important enough to want to assure that it is written:
            // logmsg.flush(); 
            result = null;
        }
        return result;
    }
    /**
    * Return minimum of a given type
    *
    * @param typeName - String containing the type name
    * @return theMin - Object whose value is the minimum for the type.
    *
    **/
    public static final Object extrema( String typeName, boolean min )
    {
        int i = Constants.getTypeIndex( typeName );
        switch ( i )
        {
        case Constants.TYPE_BYTE:
            return (min) ? new Byte( Byte.MIN_VALUE ) : new Byte( Byte.MAX_VALUE );
        case Constants.TYPE_SHORT:
            return (min) ? new Short( Short.MIN_VALUE ) : new Short( Short.MAX_VALUE);
        case Constants.TYPE_INT:
            return (min) ? new Integer( Integer.MIN_VALUE ) : new Integer( Integer.MAX_VALUE);
        case Constants.TYPE_LONG:
            return (min) ? new Long( Long.MIN_VALUE ) : new Long( Long.MAX_VALUE);
        case Constants.TYPE_FLOAT:
            return (min) ? new Float( Float.MIN_VALUE ) : new Float( Float.MAX_VALUE);
        case Constants.TYPE_DOUBLE:
            return (min) ? new Double( Double.MIN_VALUE ) : new Double( Double.MAX_VALUE);
        case Constants.TYPE_BOOLEAN:
            return (min) ? Boolean.FALSE : Boolean.TRUE ;
        case Constants.TYPE_CHAR:
            return (min) ? new Character( Character.MIN_VALUE ) : new Character( Character.MAX_VALUE);
        case Constants.TYPE_STRING:
            return (min) ? new String( "" ) : new String( MAXIMUM_CHARS, 0, MAXIMUM_CHARS.length);
        default:
            break;
        }
        return null;
    }
}