/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/policies/configure/Messages.java,v 1.2 2000/09/25 00:48:33 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/

package com.adobe.rice.common.policies.configure;

import java.util.*;
import org.xml.sax.*;
import com.adobe.rice.common.XMLdisassembly.*;

class Messages {
    
    //
    // generic configuration error messages
    //
    static final String invalid = "Purported {0} with value, {1}, is invalid!, {2}!";
    // Purported <element type> with value, <bad value>, is invalid! <specfic error message>!
    
    //
    // Conversion error messages
    //
    static final String conversionError = "Attempt to convert ->|{0}|<- to type {1} failed with " +
        "exception: {2} !";
    static final String selectionError = " Element, {0}, policy named, {1}, failed with exception: {2}!";
    
    //
    // Models for element errors
    //
    static final String elementInvalid = "Element, {0} is invalid because {1}!";
    static final String elementUnknown = "Element, {0} is not a defined, it will be ignored.";
    
    //
    // Fragments for element errors:
    //
    static final String noCharactersInModel = "element cannot contain characters";
    static final String emptyContent = "attribute or element has no content";
    static final String duplicateContentElement = " content element duplicated, last one encountered overrides.";
    static final String noItemSelected = " no item was selected.";
    static final String elementMustHaveName = " element must be named.";
    
    //
    // Fragments for attribute errors
    //
    static final String attributeUnknown = "Attribute with name {0}, and value {1} on element, {2}, is unknown.";
    static final String attributeTypeInvalid = "Attribute, {0} must have {1} type.";
    static final String attributeRangeInvalid = "Attribute, {0} with value {1} "
        + "must be in range {2} to {3}.";
    static final String attributeEnumInvalid = "Attribute, {0} with value {1} is not "
        + "a valid choice.";
    static final String attributeInvalid = "Attribute, {0} with value {1} is invalid "
        + "because: {2}.";
    
    //
    // Fragments for all configuration content model errors
    //
    static final String UnknownElementReturned = "Element {0} returned a result; but is not in Element {1}'s "
            + "content model.";
    //
    // Fragments for UUIDhandler:
    //
    static final String UUIDcharactersInvalid = " Characters must be hexadecimal, dashes, or blanks ";
    static final String UUIDtoManyCharacters = " To many hex digits for UUID ";
    
    //
    // Fragments for Enumeration Handler
    //
    static final String unknownTypeInEnumeration = " unknown type for enumeration so no policy constructed.";
    static final String itemSelectionFailed = ", item selection failed. ";
    static final String selectionIdRequired = ", an id attribute is required for this item to be selectable.";
    static final String itemValueRequired = ", an item value is required and is missing!";
    static final String noItemsInEnumeration = " no items were in the enumeration!";
    //
    // Messages for Configuration Handler (Content summarization handlers)
    //
    static final String numberOfErrorsEncountered = "{0} reported {1,number,integer} errors.";
    static final String levelOfErrorsEncountered = "{0} higest severity error was {1}.";
    static final String noErrorsEncountered = "{0} had no errors reported.";
    //
    // Fragments for Policy Handler
    //
    static final String policyClassError = "{0} requires class {1}, class {2} was constructed from configuration file.";
    static final String policyNotSet = "{0} - no policy constructed, policy not set.";
    static final String policyPackageMissing = "{0} with name {1} has no package specified; defaults to ALL packages.";
    //
    // Fragments for Range Handler Errors
    //
    static final String unknownTypeInRange = "{0} with name {1} has unknown type, {2}. No policy was constructed.";
    static final String defaultValueInvalid = "{0} with name {1} has invalid default value, {2}.  It is the wrong " +
        "type or it is out of range.  No policy was constructed.";
}