/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/scheduling/DispatchScheduleItem.java,v 1.2 2000/11/27 20:19:41 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/

package com.adobe.rice.common.scheduling;

import com.adobe.rice.util.time.*;

/**
 * ScheduleItems contain information needed to execute events. Events initiate
 * many activities (e.g., content push, content pull, and delivery retries).
 *
 */
public class DispatchScheduleItem 
{
	private Runner runner;
	private IceDateTime starttime;
	private IceDuration duration; // this is unused for now.
	
	public DispatchScheduleItem(Runner runner, IceDateTime starttime, 
								IceDuration duration) 
	{
		this.runner=runner;
		this.starttime=starttime;
		this.duration=duration;
	}
	
	public void execute() 
	{
		/* TODO. is this more than starting the runner?
		TODO. long-termn. do we come back and micro-optimize the schedule?
		we could use duration and have a DSI sleep for a bit then run in a 
		super-optimized fashion. just a thought. jdh
		*/
		runner.start();
	}

	public IceDateTime getStarttime() 
	{
		return starttime;
	}
	
	public boolean equals(DispatchScheduleItem other) 
	{
		return (starttime.equals(other.starttime)	
				&& runner.equals(other.runner));
	}
	
	public boolean before(DispatchScheduleItem other) 
	{
		return starttime.before(other.starttime);
	}

	public boolean after(DispatchScheduleItem other) 
	{
		return starttime.after(other.starttime);
	}
	
}
