/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/scheduling/PerishableDispatchSchedule.java,v 1.1.1.1 2000/09/19 19:39:49 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/

package com.adobe.rice.common.scheduling;

import java.util.*;

import com.adobe.rice.util.time.*;
//$JDK1.1$ import com.sun.java.util.collections.*;
import com.adobe.rice.util.*;


public class PerishableDispatchSchedule extends Thread {
	private IceDateTime birth, death;
	private List items;
	private boolean immutable;
	
	public PerishableDispatchSchedule(IceDateTime birth, IceDateTime death) {
		this.birth=birth;
		this.death=death;
		 // need fast, continual access. immutable once built and executed.
		items=new ArrayList();
		immutable=false; 
	}
	
	public void add(DispatchScheduleItem item) throws ObjectImmutableException{
		if (immutable)
			throw new ObjectImmutableException();
		else
			items.add(item);
	}
	
	public void run() {
		immutable=true;
		Collections.sort(items);
		
		// TODO go through and figure out what it really does to schedule stuff!
		// get threading help, please.
		Iterator itemsIt = items.iterator();
		while (itemsIt.hasNext()) {
			
			DispatchScheduleItem cur = (DispatchScheduleItem) itemsIt.next();
			IceDateTime now = new IceDateTime();
			
			// if we have to wait, then sleep accordingly.
			if (cur.getStarttime().after(now)) {
				long sleepamt =cur.getStarttime().subtract(now).getTotal();
				try{
					this.sleep(sleepamt);
				}
				catch (Exception e) {}
			}		
			launch(cur);
		}
	}
	
	private void launch(DispatchScheduleItem item) {
		// this might eventually go through and *think* about how to launch
		item.execute();	
		
	}
}
