/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/scheduling/ScheduleManager.java,v 1.5 2000/11/22 21:16:53 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/

package com.adobe.rice.common.scheduling;

// java imports
//
import java.util.*;

//
// icecubes imports:
//
import com.adobe.rice.kernel.*;
import com.adobe.rice.common.*;
import com.adobe.rice.common.policies.*;
//$JDK1.1$ import com.sun.java.util.collections.*;

import com.adobe.rice.util.time.*;
import com.adobe.rice.util.*;

public class ScheduleManager extends IceCubeManager
{
    private static MasterSchedule masterSchedule;
    private static ScheduleManager _instance;
    
    // implement singleton pattern
    //
    private ScheduleManager() throws DispatcherException
    {
        super ("ScheduleManager", MessageDispatcher.instance ());
    };
    
    public static ScheduleManager instance()
    {
        if ( _instance == null )
        {
            try
            {
                _instance = new ScheduleManager();
            }
            catch ( DispatcherException de )
            {
                // $FIX$ output the exeception message and log it if possible
                System.out.println(" Schedule Manager Exception -- Schedule Manager Failure!");
                System.out.println( de.getMessage() );
                System.exit(-9002);
            }
        }
        return _instance;
    }
    //
    // implement Manager
    //

    public void preInitialize() { }
    public void initialize() 
    {
        masterSchedule = new MasterSchedule();
    }
    public void postInitialize() { }
    //
    public void run() 
    { 
        masterSchedule.run(); 
    }
    //
    public void preFinalize() { }
    public void finalize() { }
    public void postFinalize() { }
    
}