/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/subscription/Subscribe.java,v 1.3 2000/11/21 02:33:55 andrewf Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/

package com.adobe.rice.common.subscription;
import com.adobe.rice.common.negotiation.*;
import com.adobe.rice.util.*;
/* FIX */
import com.adobe.rice.kernel.*;

public interface Subscribe
{
    // getIceCatalog returns the entire Catalog
    // @returns Response containing reference to iceCatalog
    public Response getIceCatalog ();
    
    // getIceCatalog return a parts of the iceCatalog 
    // corresponding to a particular product-name
    // 
    // @parameter product-name  product name
    // @return Response
    public Response getIceCatalog (String productName); 
    
    // get a subscription Offer from the catalog
    public Response getSubscriptionOffer (String offerId);

    // add a subscription Offer
    public Response addSubscriptionOffer (Offer newOffer);
             
    //check for the existance of the Subscriber          
    public Response authenticateSubscriber (UUID senderUUID);
             
    // add a new subscription         
    public Response newSubscription (Offer newSubscription,
                                     UUID  subscriber);
    
    // change a subscription          
    public Response changeSubscription (String subscriptionId,
                                        String  changedOfferId);
                                        
    /* section 4.6.1 */                                    
    public Response cancelSubscription (String subscriptionId);
    
    
    public Response getSubscriptionStatus (String subscriptionId);
}