/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/subscription/SubscriptionManager.java,v 1.2 2000/11/21 02:33:55 andrewf Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/

package com.adobe.rice.common.subscription;
import com.adobe.rice.common.negotiation.*;
import com.adobe.rice.kernel.*;
import com.adobe.rice.util.*;

public class SubscriptionManager extends IceCubeManager
                                 implements Subscribe
{
    
    //  NOTE: work has to be done to come up with a 
    //  more intelligent way to deal with Managers
    //  and their proxies.
    
    private static SubscriptionManager subscriber;
    private static SubscriptionProxy   proxy;
   
    private boolean debugFlag = false;
   
    static
    {
        try
        {
            proxy      = new SubscriptionProxy ();
            subscriber = new SubscriptionManager ();
        }
        catch (DispatcherException de)
        {
            de.printStackTrace ();
        }
    }
        
        
    /*
       NOTE - Visual Cafe seems to not allow inner classes
       to access protected methods
    */
    class SubscriptionRunner extends IceRunner
    {
        private IceMessage message;
        private IceMessage response;
        
        public SubscriptionRunner (IceMessage message) 
                                  throws DispatcherException
        {
           super (Thread.currentThread ().getName (),
                  MessageDispatcher.instance ());
            
           this.message = message;      
        }
        
        public void run ()
        {
           IceMessage reply = null;
           
           switch (message.getAction ())
           {
              case com.adobe.rice.kernel.Constants.iceGetCatalog: 
              if (debugFlag)
              {  
                 String i = "ice-get-catalog request received <br>";
                 System.out.println (i);
                 reply = new IceMessage (message, i);
              }
              
              break;
               
              case com.adobe.rice.kernel.Constants.iceGetSubscriptionOffer:
              if (debugFlag)
              {
                 String i = "ice-get-subscriptionOffer received <br>";
                 System.out.println (i);
                 reply = new IceMessage (message, i);
              }
              
              break;
              
              case com.adobe.rice.kernel.Constants.iceAddSubscriptionOffer:
              if (debugFlag)
              {
                 String i = "ice-add-subscriptionOffer request received <br>";
                 System.out.println (i);
                 reply = new IceMessage (message, i);
              }
              
              break;
              
              case com.adobe.rice.kernel.Constants.iceRemoveSubscriptionOffer:
              if (debugFlag)
              {
                 String i = "ice-remove-subscriptionOffer request received <br>";
                 System.out.println (i);
                 reply = new IceMessage (message, i);
              }               
              
              break;
              
              case com.adobe.rice.kernel.Constants.iceAuthenticate:
              if (debugFlag)
              {
                 String i = "ice-authenication request received <br>";
                 System.out.println (i);
                 reply = new IceMessage (message, i);
              }
            
              break;
              
              case com.adobe.rice.kernel.Constants.iceNewSubscription:
              if (debugFlag)
              {
                 String i = "ice-new-subscription request received <br>";
                 System.out.println (i);
                 reply = new IceMessage (message, i);
              }
            
              case com.adobe.rice.kernel.Constants.iceChangeSubscription:
              if (debugFlag)
              {
                 String i = "ice-new-subscription request received <br>";
                 System.out.println (i);
                 reply = new IceMessage (message, i);
              }
            
            
              default:
              if (debugFlag)
              {
                 String i = "unknown request received <br>";
                 System.out.println (i);
                 reply = new IceMessage (message, i);
              }
           }
           
           reply (reply);
        }
    }
  
    /*************** body of the SubscriptionManager *********/
  
    public Response getIceCatalog ()
    {
        Response response = null;
        
        return response;
    }
    
    public Response getIceCatalog (String productName)  
    {
        Response response = null;
        
        return response;
    }
    
    // get a subscription Offer from the catalog
    public Response getSubscriptionOffer (String offerId)
    {
        Response response = null;
        
        return response;
    }

    public Response addSubscriptionOffer (Offer newOffer)
    {
        Response response = null;
    
        return response;
    }
                    
    public Response authenticateSubscriber (UUID senderUUID)
    {
        Response response = null;
        
        return response;
    }
                         
    public Response newSubscription (Offer newSubscription,
                                     UUID  subscriber)
    {
        Response response = null;
        
        return response;
    }
                  
                                                 
    public Response changeSubscription (String subscriptionId,
                                        String changedOfferId)
    {
        Response response = null;
        
        return response;
    }
    
                  
    public Response getSubscriptionStatus (String status)
    {
        return null;
    }
    
    
    public Response cancelSubscription (String subscriptionId)
    {
        return null;
    }
                                         
    /**************** constructor *****************************/
   
	protected SubscriptionManager () throws DispatcherException
	{ 
		super ("subscription-manager", MessageDispatcher.instance ());
	}

		
	public static Subscribe instance ()
	{
	    return proxy;
	}
	
	
    public void finalize()
    {
        // This method is derived from class com.adobe.rice.kernel.IceCubeManager
        // to do: code goes here
    }

    public void initialize()
    {
        // This method is derived from interface com.adobe.rice.common.Manager
        // to do: code goes here
    }

    public void postFinalize()
    {
        // This method is derived from interface com.adobe.rice.common.Manager
        // to do: code goes here
    }

    public void postInitialize()
    {
        // This method is derived from interface com.adobe.rice.common.Manager
        // to do: code goes here
    }

    public void preFinalize()
    {
        // This method is derived from interface com.adobe.rice.common.Manager
        // to do: code goes here
    }

    public void preInitialize()
    {
        // This method is derived from interface com.adobe.rice.common.Manager
        // to do: code goes here
    }


    // NOTE: we will initially start with an iterative
    // version of the manager which implements a thread
    // on demand. This will change to a thread pool.
    public void run()
    {
       IceMessage request;
       IceMessage reply = null;
       Runnable   runner;
       
       // have to come up with an efficient method
       // shutting down the manager
       
       while (true)
       {
           try
           {
              request = (IceMessage) receive ();
              runner = new SubscriptionRunner (request);
              new Thread (null, runner, getName ()).start ();
           }
           catch (DispatcherException e)
           {
              e.printStackTrace ();
           }
       }
    }   
}