/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/transportation/HTTPtransport.java,v 1.2 2000/12/02 23:31:13 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/

package com.adobe.rice.common.transportation;

import java.io.*;
import java.net.*;
import java.util.*;

//
// icecubes imports
//
import com.adobe.rice.common.*;
import com.adobe.rice.common.policies.*;
import com.adobe.rice.common.payloadAssembly.*;
import com.adobe.rice.common.XMLdisassembly.*;
import com.adobe.rice.common.payloadDisassembly.*;
import com.adobe.rice.kernel.*;

public class HTTPtransport implements TransportProtocol
{
    public HTTPtransport()
    {
        // nothing to initialize yet...
    }
    
	public Reader sendRequest( Payload sendPayload, URL location  )
	{
	    String thePacket = sendPayload.toXMLstring();
	    
	    int logLevel = ((Integer) PolicyManager.instance().getSafeSelection("LoggingLevel", new Integer( 0 ) ) ).intValue();
	    
	    if ( logLevel > 8 )
	    {   // Write packet to log if really want detail!
            Object[] parms = { "sendRequest", thePacket };    
            TransportMessages.log(TransportMessages.get("GeneratedPacket"), parms, 100000000 );
	    }
	    URLConnection connection = null;
	    
	    Reader inReader = null;
	    
	    try 
	    { 
	        connection = location.openConnection(); 
    	    
	        // construct and open the URL connection to location.
	        InputStream in = connection.getInputStream();
	        OutputStream out = connection.getOutputStream();
    	    
	        inReader = new InputStreamReader(in);
    	    
	        Writer outWriter = new OutputStreamWriter(out);
    	    
	        outWriter.write(thePacket);
    	    
	        outWriter.close();
	    }    
	    catch ( IOException ioe ) {} // $FIX$
	    
	    
	    return inReader;
	    
	    /*
	    
        XMLDisassembler     disassembler;
      
        disassembler = new XMLDisassembler("http-Response", inReader);  
    
        PayloadHandler ph = new PayloadHandler(disassembler, this, routing);
      
        disassembler.registerHandler("ice-payload", ph);
        
        returnedPayload = disassembler.parse ();
        
        inReader.close();
        
        return returnedPayload;
        
        */
	    
	}
	
	public void receiveRequest( Reader inputRequest, Writer outputResponse )
	{
        XMLDisassembler     disassembler;
        String          routing = "http-receiveRequest";
      
        disassembler = new XMLDisassembler("http-receiveRequest", inputRequest, outputResponse );  
    
        PayloadHandler ph = new PayloadHandler(disassembler, routing);
      
        disassembler.registerHandler("ice-payload", ph);
        disassembler.parse ();
	}
	
	public boolean canUseProtocol(String protocolString)
	{
	    return true;
	}
}