/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/transportation/TransportManager.java,v 1.5 2000/12/02 23:31:13 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/

package com.adobe.rice.common.transportation;

import java.io.*;
import java.util.*;

//
// icecubes imports
//
import com.adobe.rice.common.*;

import com.adobe.rice.common.XMLdisassembly.*;
import com.adobe.rice.common.payloadDisassembly.*;
import com.adobe.rice.kernel.*;

public class TransportManager extends IceCubeManager
{
	private static TransportManager	transportManager;
	
	private HashMap	registeredProtocols;
		
	public static TransportManager instance()
	{
	    if ( transportManager == null )
	    {
	        try 
	        {
	            transportManager = new TransportManager();
	        }
	        catch ( DispatcherException de )
	        {
	        }
	    }
	    return transportManager;
	}
	
	private TransportManager() throws DispatcherException
	{
	    super( "TransportManager" );
	    transportManager = this;
		registeredProtocols = new HashMap();
	}
	
	public void registerTransportProtocol(String name, TransportProtocol transportProtocol) 
	{
	    if ( registeredProtocols.containsKey(name) )
	    {
	        registeredProtocols.remove(name);
	    }
		registeredProtocols.put(name, transportProtocol);
	}
	
	public void unregisterTransportProtocol(String name)
	{
		registeredProtocols.remove(name);
	}
	
	public TransportProtocol getTransportProtocol( String name )
	{
	    if ( registeredProtocols.containsKey(name) )
	        return (TransportProtocol) registeredProtocols.get(name);
	    return null;
	}
	
	public void receive(Reader input, String routing) 
	{
      XMLDisassembler   disassembler;
      
      disassembler = new XMLDisassembler("http", input);  
    
      PayloadHandler ph = new PayloadHandler(disassembler, routing);
      
      disassembler.registerHandler("ice-payload", ph);
      disassembler.parse ();
	}
		
	//
    // implement Manager
    //
    //
    // Execution Activity Logic
    //
    public void preInitialize() { }
    public void initialize() { }
    public void postInitialize() { }
    //
    public void run() { }
    //
    public void preFinalize() { }
    public void finalize() { }
    public void postFinalize() { }



}
