/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/common/transportation/TransportMessages.java,v 1.2 2000/12/02 23:31:13 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/

package com.adobe.rice.common.transportation;

//
// java imports
//
import java.util.*;
//
// icecubes imports
//
import com.adobe.rice.common.asks.*;
import com.adobe.rice.common.storage.logging.*;

public class TransportMessages extends ListResourceBundle 
{
	public static String get(String message) 
	{
		ResourceBundle res = ResourceBundle.getBundle("com.adobe.rice.common.transportation.TransportMessages");
		return res.getString(message);
	}
	
	public Object[][] getContents() { return contents; }
	
	static Object[][] contents = 
	{
        //
        // generic error messages
        //
        { "invalid",                  "Purported {0} with value, {1}, is invalid!, {2}!"},
        // Purported <element type> with value, <bad value>, is invalid! <specfic error message>!
        { "missingRequiredAttribute", "Element {0} with attribute name, {1}, is missing REQUIRED value of type {2}!" },
        { "invalidAttribute",         "Element {0}, invalid attribute value, exception message {1}" },
        //
        { "characterDataBad",         "Unable to insert character data into element, {0}, exception {1}." },
        { "contentInvalid",           "Unable to add content type {0}, to element, {1}, exception {2}." },
        { "documentFailed",           "Unable to construct Document {0} for {1}, message {2}." },
        //
        { "attributeSetFailed",       "Element {0} attribute {1} set value failed with: {2}."},
        { "GeneratedPacket",          "{0} Packet Generated: -->|{1}|<--" },
        { "ReceivedPacket",           "{0} Received Packet:  -->|{1}|<--" }
        
	};
	
	static String thePackageName = "common.transportation";
	
	public void setupLog( String thePackage )
	{
	    thePackageName = thePackage;
	}
	
	public static void log( String prototype, Object[] parms, int theErrorNumber )
	{
        LogMsg logmsg = new LogMsg( prototype , parms );
        logmsg.prolog( thePackageName, theErrorNumber, ImpactRange.getImpact(theErrorNumber) );
        logmsg.log();
        if ( theErrorNumber > ImpactRange.impactOf("serious") )
            logmsg.flush(); // when this should be done!
    }
	
	public static void log( String prototype, Object[] parms, int theErrorNumber, 
	                 String theErrorText )
	{
        LogMsg logmsg = new LogMsg( prototype , parms );
        logmsg.prolog( thePackageName, theErrorNumber, theErrorText) ;
        logmsg.log();
        if ( theErrorNumber > ImpactRange.impactOf("serious") )
            logmsg.flush(); // when this should be done!
	}
}
