/*
$Log: DispatcherException.java,v $
Revision 1.2  2000/10/25 22:04:27  andrewf
added documentation and instructions

$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/kernel/DispatcherException.java,v 1.2 2000/10/25 22:04:27 andrewf Exp $
$Author: andrewf $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org
*/

//
// DispatcherException indicates whether a critical error has 
// occured in the dispatcher. The idea was eventually some
// deadlock avoidance/detection would be placed in the dispatcher.
// However I have to decide whether throwing an exception is the
// right thing to do, or just expand the number of error codes and
// force the user to write logic to handle this.
//

package com.adobe.rice.kernel;

public class DispatcherException extends Exception
{
    private String errorString;
    
    public DispatcherException ()
    {       
    }
    
    public DispatcherException (String errorString)
    {
        this.errorString = errorString;
    }
}