package com.adobe.rice.kernel.tests;
import com.adobe.rice.kernel.*;

 
// if test one is successful, the  
 
public class MailQueueTest
{
    private static MailQueue mailQueue;
    
    public static void main (String argv[])
    {
        //IndefiniteBlocking ();
        TimedBlocking ();
    }
        
   
    public static void IndefiniteBlocking ()
    {    
        mailQueue = new MailQueue ();
        Thread consumer [] = new Thread[5];
        
        for (int n = 0 ; n < 5 ; n++)
        {
            consumer[n] = new Thread (Integer.toString (n))
                          {
                              public void run ()
                              {
                                  Object element;
                                  String name;
                                
                                  name = Thread.currentThread().getName ();
                                  try
                                  {
                                     while (true)
                                     {
                                        System.out.println (name + "about to remove message");
                                        element = mailQueue.remove();
                                        System.out.println (name + "removed message " + element);
                                     }
                                  }
                                  catch (InterruptedException e)
                                  {
                                     e.printStackTrace ();
                                  }
                              } 
                           };
        }
        
        Thread producer = new Thread ()
                              {
                                public void run ()
                                {
                                   String element = "hello world from producer";
                                   
                                   
                                   try
                                   {
                                      sleep (5000);
                                      
                                      for (int i = 0 ; i < 10 ; i++)
                                      {
                                          
                                          sleep (2000);
                                          mailQueue.add (element + " " + i);
                                      }
                                   }
                                   catch (InterruptedException e)
                                   {
                                      e.printStackTrace ();
                                   }
                                 }      
                              };
                          
            for (int i = 0 ; i < 5; i++)
            {
                consumer[i].start ();
            }
            
            producer.start ();
     }
     
    public static void TimedBlocking ()
    {    
        mailQueue = new MailQueue ();
        Thread consumer [] = new Thread[5];
        
        for (int n = 0 ; n < 5 ; n++)
        {
            consumer[n] = new Thread (Integer.toString (n))
                          {
                              public void run ()
                              {
                                  Object element;
                                  String name;
                                  long now;
                                
                                  name = Thread.currentThread().getName ();
                                  try
                                  {
                                     while (true)
                                     {
                                        System.out.println (name + "about to remove message");
                                        now = System.currentTimeMillis ();
                                        element = mailQueue.remove(4000);
                                        if (element == null)
                                        {
                                           System.out.print (name + " timed out :");
                                           System.out.println (System.currentTimeMillis () - now);
                                        }
                                        else
                                        {
                                           System.out.println (name + "removed message " + element);
                                        }
                                     }
                                  }
                                  catch (InterruptedException e)
                                  {
                                     e.printStackTrace ();
                                  }
                              } 
                           };
        }
        
        Thread producer = new Thread ()
                              {
                                public void run ()
                                {
                                   String element = "hello world from producer";
                                   
                                   
                                   try
                                   {
                                      sleep (5000);
                                      
                                      for (int i = 0 ; i < 10 ; i++)
                                      {
                                          
                                          sleep (2000);
                                          mailQueue.add (element + " " + i);
                                      }
                                   }
                                   catch (InterruptedException e)
                                   {
                                      e.printStackTrace ();
                                   }
                                 }      
                              };
                          
            for (int i = 0 ; i < 5; i++)
            {
                consumer[i].start ();
            }
            
            producer.start ();
     } 
}

      