/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/servlet/ICEServlet.java,v 1.4 2000/12/02 23:37:12 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

One or more classes in ICEcubes have been written by:

V. Bruce Hunt,                  Technical Lead & Vice Chair, ICE-AG, 
    vbhunt@sourceforge.net      Adobe Systems, Inc.
    
Jonathan Herbach                Developer           
    jherbach@adobe.com          Princeton University & Adobe Systems, Inc.
    
Will Conant                     Developer
                                University of Utah & Adobe Systems Inc.

Andrew Francis                  Developer           
    afrancis@adobe.com          Adobe Systems, Inc.
    
Anna Shamble                    Developer           
    ashamble@adobe.com          Santa Clara University & Adobe Systems, Inc.

Authors of various classes are noted in the headings 

*/

/*----------------------------------------------------------------------------------------+
 |                                                                                        |
 |                              Reference Implementation of ICE                           |
 |                                                                                        |
 |                   ICEServlet - Interface to TomCat for ICEcubes                        |
 |                                                                                        |
 +----------------------------------------------------------------------------------------*/ 
 
package com.adobe.rice.servlet;

import javax.servlet.*;
import javax.servlet.http.*;

import  java.io.*;
import  java.lang.*;

//import  com.adobe.rice.*;
import  com.adobe.rice.common.Tray;
import  com.adobe.rice.kernel.*;
import  com.adobe.rice.common.transportation.*;

//
//  ICEServlet is the class that embeds an 
//  ICEProcessor. 

public class ICEServlet extends HttpServlet
                                implements Runnable
{
    public static Tray tray;
    
    // The ICEProcessor initialization method
    // is embedded in the servlet's init
    public void init (ServletConfig config)
                     throws ServletException
    {
        try
        {
           System.out.println ("ICEcubes -- ICE Reference Implemetation Starting.");
           //
           // open the tray!
           //
           tray = new Tray();
           //
           // run till we drop
           //
           Thread base = new Thread(tray);
           base.start();
           if ( false )
           {
                //
                // wait until tray stops
                //
                try { base.join(); }
                catch (InterruptedException e ) { e.printStackTrace(); }
                //
                // Announce that we are leaving:
                //
                System.out.println("ICEcubes -- ICE Reference Implementation Ending.");
           }
        }
        catch (DispatcherException e)
        {
            e.printStackTrace ();
        }
    }
    
    // The ICEProcessor's inbound payload handler
    // is embedded inside a doPost
    public void doPost (HttpServletRequest request,
                        HttpServletResponse response)
    {
       Writer                output;
       Reader                input;
       HTTPtransport         http = new HTTPtransport();
       
       try
       {
          output = response.getWriter();
          
          // return type is x-ice-application
          response.setContentType("application/x-ice");
      
          //get the Reader Stream from the request 
          input = request.getReader();
       
          //and have the "IcePayloadDispatcher" process it
          http.receiveRequest(input, output);
          
          input.close();
          output.close();
       }
       catch (IOException e)
       {
       }
     }
       
    // doGet () should not be supported
    // by processors
    public void doGet(HttpServletRequest request,
                       HttpServletResponse response)
                       throws ServletException
    {
     
        
        
    }
    
    // All of the ICEProcessor's background processing
    // gets started here
    public void run ()
    {
        
        
    }
    
    // when the ICEServlet is about to be destroyed
    // it runs the following ICE processor method
    public void destroy ()
    {
        
    }
}