package com.adobe.rice.servlet.drivers;
import java.io.*;
import java.net.*;
import java.util.*;

// Servlet driver is a test driver for the 
// ICEServlet

public class ServletDriver2
{
    static byte[] buffer;
    
    public static boolean ReadFromFile (FileInputStream fd)
                                        
    {
        int available = 0;
        int read = 0;
        int count = 0;
        
        try
        {
           available = fd.available();
           buffer = new byte [available + 1];
           read = fd.read (buffer,0,available);
        }
        catch (IOException e)
        {
           e.printStackTrace ();   
        }
       
        return (read == available) ;                               
    }
    
    public static void PostToServer (URLConnection connection)
    {
        String f; 
        OutputStreamWriter o;
        
        // f is now a string representation of the buffer
        f = new String (buffer);
        
        try
        {
           o = new OutputStreamWriter (connection.getOutputStream ());
           
           // write the HTTP POST preamble
           //o.write ("POST /examples/IceServlet HTTP/1.0 \n");
           //o.write ("From: andrewf@adobe.com \n");
           //o.write ("User-Agent: ICEdriver 1.0 \n");
           //o.write ("Content-type: application/x-ice \n");
           //o.write ("Content-length: " + (f.length () - 2) + "\n");
           
           //tell the web server that the preamble has ended 
           //o.write ("\n\n");
           
           //and send the output
           o.write (f);
           
           // close the OutputStreamWriter
           o.close ();
        }
        catch (IOException e)
        {
            
        }
    }
    
    public static void ReadFromServer (URLConnection connection)
    {
         String line;
         
         try
         {
            InputStreamReader i = new InputStreamReader 
                                 (connection.getInputStream ());
                               
            BufferedReader b = new BufferedReader (i);
           
            while ((line = b.readLine ()) != null)
            {
               System.out.println (line);
            }
             
            b.close ();
         }
         catch (IOException e)
         {
             e.printStackTrace ();        
         }
    }
    
    
    public static void main (String[] args)
    {        
        try
        {
           FileInputStream fd = new FileInputStream (args[1]);
           ReadFromFile (fd);
         
           URL url =  new URL (args[0]) ;
           URLConnection connection = url.openConnection ();
           connection.setDoOutput (true);
           connection.setDoInput (true);
     
           //Post XML file to server
           PostToServer (connection);
     
           // and read its response
           ReadFromServer (connection);
           
           // close the file
           fd.close ();  
           
        }
        catch(Exception e)
        { 
            e.printStackTrace(); 
        }
    }
} 
    