package com.adobe.rice.util;
import java.util.*;

// Ordered Set preserves the order in which elements are
// introduced to the set

public class OrderedSet extends java.util.AbstractSet implements java.util.Collection, java.util.Set
{
    private LinkedList list;
    
    public OrderedSet ()
    {
        list = new LinkedList ();   
    }
    
    public OrderedSet (Collection c)
    {
       Object element;
       list = new LinkedList ();
       
       Iterator i = c.iterator ();
       while (i.hasNext ())
       {
          element = i.next ();
          if (!list.contains (element))
          {
             list.add (element);
          }
       }
    }
    
    public Object first ()
    {
        return list.getFirst ();
    }
    
    public Object last ()
    {
        return list.getLast ();
    }
    
    public boolean add (Object o)
    {
        if (list.contains (o))
        {
           return false;
        }
        else
        {
            return list.add (o);
        }
    }

    public boolean addAll(Collection c)
    {
        
        Iterator i = c.iterator ();
        Object   e;
        
        while (i.hasNext())
        {
           e = i.next ();
           if (list.contains (e)) 
           {
              return false;
           }
        }
        
        return list.addAll (c);
    }


    public void clear()
    {
        list.clear ();
    }

    public boolean contains(Object o)
    {
        return list.contains (o);
    }

    public boolean containsAll(Collection c)
    {
        return list.containsAll (c);
    }

    public boolean equals(Object o)
    {
        if (!(o instanceof OrderedSet))
        {
           return false;
        }
       
        return list.equals (((OrderedSet) o).list);
    }

    public int hashCode()
    {
        return list.hashCode ();
    }

    public boolean isEmpty()
    {
        return list.isEmpty ();
    }

    public Iterator iterator()
    {
        return list.iterator ();
    }

    public boolean remove(Object o)
    {
        return list.remove (o);
    }

    public boolean removeAll(Collection c)
    {
        return list.removeAll (c);
    }

    public boolean retainAll(Collection c)
    {
        return list.retainAll (c);
    }

    public int size()
    {
        return list.size ();
    }

    public Object[] toArray(Object a[])
    {
        return list.toArray (a);
    }

    public Object[] toArray ()
    {
        return list.toArray ();
    }
    
    public String toString ()
    {
        return list.toString ();
    }

    public static void main (String argv[])
	{
	    Object list [] = {"a","b","c","d","e"};
	    Object list2 [] = {"e","e","d","b","c","a","a"};
	    TreeSet bar;
	    
	    OrderedSet foo = new OrderedSet ();
	    
	    for (int n = 0 ; n < list2.length  ; n++)
	    {
	        if (!foo.contains (list2[n]))
	           foo.add (list2 [n]);
	    }
	    
	    System.out.println (foo);
	}
}