/*
$Header: /opt/repository/icecubes/Rice/code/com/adobe/rice/util/time/IceDay.java,v 1.1.1.1 2000/09/19 19:39:51 bhunt Exp $

ICEcubes - Reference implementation of the Information and Content Exchange Protocol
Copyright (C) 1998 - 2000 ICE Authoring Group

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The ICE Authoring Group thanks Adobe System's Inc. for supporting 
the initial development of ICEcubes.

This library was written on behalf of the ICE Authoring Group, affialiated
with GCA's IdeaAlliance.  For the latest information on ICE see 

http://www.icestandard.org

*/

package com.adobe.rice.util.time;



public class IceDay {
	private byte monthday;
	private byte weekday;
	
/**   Monthday provides a namespace for additional date tokens.   */
	public static class Monthday {
		static final byte MINVAL = -1;
		public static final byte ANY = 0;
		// bytes [1,31] are acceptable Monthdays as per ICE spec.
		public static final byte LAST = 32;
		static final byte MAXVAL = 33;
	}
/**   Weekday provides a namespace for additional day tokens.   */
	public static class Weekday {
		static final byte MINVAL = -1;
		public static final byte ANY = 0;
		//public static final byte MONDAY = 1;
		//public static final byte TUESDAY = 2;
		//public static final byte WEDNESDAY = 3;
		//public static final byte THURSDAY = 4;
		//public static final byte FRIDAY = 5;
		//public static final byte SATURDAY = 6;
		//public static final byte SUNDAY = 7;
		static final byte MAXVAL = 8;

	}

	public IceDay(byte monthday, byte weekday) throws IllegalArgumentException {
		
		if (monthday > Monthday.MINVAL && monthday < Monthday.MAXVAL)
			this.monthday=monthday;
		else throw new IllegalArgumentException();

		if (weekday > Weekday.MINVAL && weekday < Weekday.MAXVAL)
			this.weekday=weekday;
		else throw new IllegalArgumentException();
		
	}
	
	public byte getMonthday() {
		return monthday;
	}
	
	public byte getWeekday() {
		return weekday;
	}
	

}


